-- SQL Manager 2005 Lite for PostgreSQL 3.4.0.4
-- ---------------------------------------
-- Host     : localhost
-- Database : clinica


--
-- Structure for table clientes (OID = 25962) : 
--
SET search_path = public, pg_catalog;
CREATE TABLE clientes (
    idcliente serial NOT NULL,
    cliente character varying NOT NULL,
    fechanacimiento date,
    direccion character varying,
    cp character varying,
    poblacion character varying,
    provincia character varying,
    telefono character varying,
    movil character varying,
    email character varying,
    clave character varying,
    observaciones character varying,
    fechaalta date DEFAULT (now())::date NOT NULL
) WITHOUT OIDS;
--
-- Structure for table empleados (OID = 25977) : 
--
CREATE TABLE empleados (
    idempleado serial NOT NULL,
    empleado character varying NOT NULL,
    fechanacimiento date,
    direccion character varying,
    cp character varying,
    poblacion character varying,
    provincia character varying,
    telefono character varying,
    movil character varying,
    email character varying,
    observaciones character varying,
    numerocolegiado character varying,
    sueldo double precision NOT NULL
) WITHOUT OIDS;
--
-- Structure for table historiales (OID = 25989) : 
--
CREATE TABLE historiales (
    idhistorial serial NOT NULL,
    idcliente integer NOT NULL,
    foto character varying,
    historiadental character varying,
    s1 integer DEFAULT 0 NOT NULL,
    s2 integer DEFAULT 0 NOT NULL,
    s3 integer DEFAULT 0 NOT NULL,
    s4 integer DEFAULT 0 NOT NULL,
    s5 integer DEFAULT 0 NOT NULL,
    s6 integer DEFAULT 0 NOT NULL,
    s7 integer DEFAULT 0 NOT NULL,
    s8 integer DEFAULT 0 NOT NULL,
    s9 integer DEFAULT 0 NOT NULL,
    s10 integer DEFAULT 0 NOT NULL,
    s11 integer DEFAULT 0 NOT NULL,
    s12 integer DEFAULT 0 NOT NULL,
    s13 integer DEFAULT 0 NOT NULL,
    s14 integer DEFAULT 0 NOT NULL,
    s15 integer DEFAULT 0 NOT NULL,
    s16 integer DEFAULT 0 NOT NULL,
    i1 integer DEFAULT 0 NOT NULL,
    i2 integer DEFAULT 0 NOT NULL,
    i3 integer DEFAULT 0 NOT NULL,
    i4 integer DEFAULT 0 NOT NULL,
    i5 integer DEFAULT 0 NOT NULL,
    i6 integer DEFAULT 0 NOT NULL,
    i7 integer DEFAULT 0 NOT NULL,
    i8 integer DEFAULT 0 NOT NULL,
    i9 integer DEFAULT 0 NOT NULL,
    i10 integer DEFAULT 0 NOT NULL,
    i11 integer DEFAULT 0 NOT NULL,
    i12 integer DEFAULT 0 NOT NULL,
    i13 integer DEFAULT 0 NOT NULL,
    i14 integer DEFAULT 0 NOT NULL,
    i15 integer DEFAULT 0 NOT NULL,
    i16 integer DEFAULT 0 NOT NULL
) WITHOUT OIDS;
--
-- Structure for table tiposmailings (OID = 26038) : 
--
CREATE TABLE tiposmailings (
    idtipomailing serial NOT NULL,
    tipomailing character varying NOT NULL
) WITHOUT OIDS;
--
-- Structure for table detallestipomailing (OID = 26050) : 
--
CREATE TABLE detallestipomailing (
    iddetalletipomailing serial NOT NULL,
    idtipomailing integer NOT NULL,
    asunto character varying NOT NULL,
    texto character varying NOT NULL
) WITHOUT OIDS;
--
-- Structure for table mailingsclientes (OID = 26067) : 
--
CREATE TABLE mailingsclientes (
    idmailingcliente serial NOT NULL,
    iddetalletipomailing integer NOT NULL,
    idcliente integer NOT NULL,
    fecha date DEFAULT (now())::date NOT NULL,
    hora time without time zone DEFAULT (now())::time without time zone NOT NULL
) WITHOUT OIDS;
--
-- Structure for table productos (OID = 26086) : 
--
CREATE TABLE productos (
    idproducto serial NOT NULL,
    producto character varying NOT NULL,
    descripcion character varying,
    precio double precision NOT NULL,
    cantidad integer NOT NULL,
    puntoreposicion integer
) WITHOUT OIDS;
--
-- Structure for table presupuestos (OID = 26098) : 
--
CREATE TABLE presupuestos (
    idpresupuesto serial NOT NULL,
    presupuesto character varying NOT NULL,
    descripcion character varying,
    observaciones character varying
) WITHOUT OIDS;
--
-- Structure for table presupuestosproductos (OID = 26110) : 
--
CREATE TABLE presupuestosproductos (
    idpresupuestoproducto serial NOT NULL,
    idpresupuesto integer NOT NULL,
    idproducto integer NOT NULL,
    cantidad integer NOT NULL,
    opcional boolean DEFAULT false NOT NULL
) WITHOUT OIDS;
--
-- Structure for table laboratorios (OID = 26130) : 
--
CREATE TABLE laboratorios (
    idlaboratorio serial NOT NULL,
    laboratorio character varying NOT NULL,
    cif character varying NOT NULL,
    direccion character varying,
    cp character varying,
    poblacion character varying,
    provincia character varying,
    telefono character varying,
    fax character varying,
    personacontacto character varying,
    email character varying,
    web character varying,
    observaciones character varying
) WITHOUT OIDS;
--
-- Structure for table pedidos (OID = 26144) : 
--
CREATE TABLE pedidos (
    idpedido serial NOT NULL,
    idlaboratorio integer NOT NULL,
    fechasolicitud date DEFAULT (now())::date NOT NULL,
    fecharecepcion date,
    recibido boolean DEFAULT false NOT NULL,
    observaciones character varying
) WITHOUT OIDS;
--
-- Structure for table detallespedidos (OID = 26161) : 
--
CREATE TABLE detallespedidos (
    iddetallepedido serial NOT NULL,
    idpedido integer NOT NULL,
    idproducto integer NOT NULL,
    cantidadpedida integer NOT NULL,
    cantidadrecibida integer,
    preciounitario double precision NOT NULL,
    precioventa double precision,
    recibido boolean DEFAULT false NOT NULL
) WITHOUT OIDS;
--
-- Structure for table facturaslaboratorio (OID = 26179) : 
--
CREATE TABLE facturaslaboratorio (
    idfacturalaboratorio serial NOT NULL,
    idpedido integer NOT NULL,
    fecha date DEFAULT (now())::date NOT NULL,
    recibida boolean DEFAULT false NOT NULL,
    pagada boolean DEFAULT false NOT NULL
) WITHOUT OIDS;
--
-- Structure for table citas (OID = 26196) : 
--
CREATE TABLE citas (
    idcita serial NOT NULL,
    idcliente integer NOT NULL,
    idempleado integer NOT NULL,
    fecha date DEFAULT (now())::date NOT NULL,
    hora time without time zone DEFAULT (now())::time without time zone NOT NULL,
    confirmada boolean DEFAULT false NOT NULL,
    realizada boolean DEFAULT false NOT NULL,
    duracionestimada integer NOT NULL,
    descripcion character varying NOT NULL
) WITHOUT OIDS;
--
-- Structure for table detallescita (OID = 26220) : 
--
CREATE TABLE detallescita (
    iddetallecita serial NOT NULL,
    idcita integer NOT NULL,
    idproducto integer NOT NULL,
    cantidad integer NOT NULL,
    precio double precision NOT NULL
) WITHOUT OIDS;
--
-- Definition for function copiarprecio (OID = 26235) : 
--
SET check_function_bodies = false;
CREATE FUNCTION copiarprecio () RETURNS "trigger"
    AS '
declare registro record;
begin
	if (new.precio is null) then
		select precio into registro from productos where idproducto = new.idproducto;
		new.precio = registro.precio;
	end if;
	return new;
end;
'
    LANGUAGE plpgsql;
--
-- Structure for table facturascliente (OID = 26239) : 
--
CREATE TABLE facturascliente (
    idfacturacliente serial NOT NULL,
    idcita integer NOT NULL,
    fecha date DEFAULT (now())::date NOT NULL,
    descuento double precision DEFAULT 0 NOT NULL,
    emitida boolean DEFAULT false NOT NULL,
    pagada boolean DEFAULT false NOT NULL,
    formapago character varying
) WITHOUT OIDS;
--
-- Definition for function importefacturalaboratorio (OID = 26258) : 
--
CREATE FUNCTION importefacturalaboratorio (integer) RETURNS double precision
    AS '
declare
	factura alias for $1;
	registro record;
begin
	select sum(dp.preciounitario) as importe into registro
	from detallespedidos dp join pedidos p
		using (iddetallepedido) join facturaslaboratorio fl
		using (idpedido)
	where fl.idfacturalaboratorio = factura;
	return registro.importe;
end;
'
    LANGUAGE plpgsql;
--
-- Definition for function importefacturacliente (OID = 26259) : 
--
CREATE FUNCTION importefacturacliente (integer) RETURNS double precision
    AS '
declare
	factura alias for $1;
	registro record;
begin
	select sum(dc.precio) as importe into registro
	from detallescita dc join citas c
		using (idcita) join facturascliente fc
		using (idfacturacliente)
	where fc.idfacturacliente = factura;
	return registro.importe;
end;
'
    LANGUAGE plpgsql;
--
-- Definition for function generarclave (OID = 26260) : 
--
CREATE FUNCTION generarclave (integer) RETURNS character varying
    AS '
declare
	paramCliente alias for $1;
	i integer;
	cadena varchar;
	semilla integer;
	caracter char;
begin
	i := 1;
	cadena := '''';
	
	while i < 10 loop
		semilla := 0;
		while (semilla < 48 or semilla > 57) and (semilla < 97 or semilla > 122) loop
			select cast(random() * 100 as integer) into semilla;
		end loop;
		select chr(semilla) into caracter;
		cadena := cadena || caracter;
		i := i + 1;
	end loop;
	
	update clientes set clave = md5(cadena) where idcliente = paramCliente and email is not null;
	return cadena;
end;
'
    LANGUAGE plpgsql;
--
-- Data for blobs (OID = 25962) (LIMIT 0,3)
--
INSERT INTO clientes (idcliente, cliente, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, clave, observaciones, fechaalta) VALUES (1, 'Alfonso Jimenez', '1943-06-18', 'C/ Virgen del Piedra', '02394', 'Elche', 'Alicante', '962348723', '634791283', 'alfonso@gmail.com', '5a8dc4ef27426080d795f22923de9fd1', NULL, '2006-06-01');
INSERT INTO clientes (idcliente, cliente, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, clave, observaciones, fechaalta) VALUES (2, 'Esther Navarro Perez', '1948-06-01', 'C/ Asuncion Parreo', '09348', 'Elda', 'Alicante', '963458723', '698345129', 'esther@gmail.com', '670b14728ad9902aecba32e22fa4f6bd', NULL, '2006-06-01');
INSERT INTO clientes (idcliente, cliente, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, clave, observaciones, fechaalta) VALUES (3, 'Lola Prez', '1991-06-01', 'C/ Vicente Blasco Ibaez', '03198', 'Elche', 'Alicante', '963489579', '694872934', NULL, NULL, NULL, '2006-06-01');
--
-- Data for blobs (OID = 25977) (LIMIT 0,4)
--
INSERT INTO empleados (idempleado, empleado, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, observaciones, numerocolegiado, sueldo) VALUES (1, 'Luis Andrs Carmelo', '1976-06-01', 'C/ Cristan Safire', '02348', 'Novelda', 'Aliante', '923841348', '623489719', NULL, NULL, '23478129', 2100);
INSERT INTO empleados (idempleado, empleado, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, observaciones, numerocolegiado, sueldo) VALUES (2, 'Carmina Sanchez', '1961-06-01', 'C/ Cristo Prez', '02418', 'Campello', 'Alicante', '928345723', '673452893', NULL, NULL, '9834384', 1400);
INSERT INTO empleados (idempleado, empleado, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, observaciones, numerocolegiado, sueldo) VALUES (3, 'Miguel Ferreiro', '1988-06-01', 'C/ Hernan Soleda', '90349', 'Elche', 'Alicante', '969843592', '678923458', NULL, NULL, NULL, 2100);
INSERT INTO empleados (idempleado, empleado, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, observaciones, numerocolegiado, sueldo) VALUES (4, 'Francisco Ibarra', '2006-06-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1100);
--
-- Data for blobs (OID = 25989) (LIMIT 0,3)
--
INSERT INTO historiales (idhistorial, idcliente, foto, historiadental, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16) VALUES (3, 3, NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
INSERT INTO historiales (idhistorial, idcliente, foto, historiadental, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16) VALUES (2, 2, '../historiales/1/', '

Carmina Sanchez 01/06/2006


Luis Andrs Carmelo 01/06/2006
El paciente presenta principio de cries en el molar derecho n 6.
Ha prescrito alergia a ms de 3 inyecciones de anestesia.
', 0, 0, 0, 2, 3, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
INSERT INTO historiales (idhistorial, idcliente, foto, historiadental, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16) VALUES (1, 1, NULL, '

Carmina Sanchez 01/06/2006


Luis Andrs Carmelo 01/06/2006


Luis Andrs Carmelo 01/06/2006


Luis Andrs Carmelo 01/06/2006


Carmina Sanchez 01/06/2006


Luis Andrs Carmelo 01/06/2006


Luis Andrs Carmelo 01/06/2006
Se le ha extrado una muela para una futura prtesis que de momento no desea ponerse.', 0, 0, 1, 0, 2, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
--
-- Data for blobs (OID = 26038) (LIMIT 0,2)
--
INSERT INTO tiposmailings (idtipomailing, tipomailing) VALUES (1, 'Felicitacin');
INSERT INTO tiposmailings (idtipomailing, tipomailing) VALUES (2, 'Advertencia');
--
-- Data for blobs (OID = 26050) (LIMIT 0,3)
--
INSERT INTO detallestipomailing (iddetalletipomailing, idtipomailing, asunto, texto) VALUES (1, 1, 'Cumpleaos', 'En nombre del equipo le desamos felicidades en su da.');
INSERT INTO detallestipomailing (iddetalletipomailing, idtipomailing, asunto, texto) VALUES (2, 1, 'Fn tratamiento', 'Enhorabuena por haber completado el tratamiento con nosotros.');
INSERT INTO detallestipomailing (iddetalletipomailing, idtipomailing, asunto, texto) VALUES (3, 2, 'Moroso', 'Por favor, realice sus pagos pendientes lo antes posible.');
--
-- Data for blobs (OID = 26086) (LIMIT 0,8)
--
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (1, 'Servicio', 'Mano de obra utilizada durante la consulta', 0, 1, 0);
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (3, 'Inyecciones de anestesia', NULL, 13.4, 0, 40);
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (6, 'Baberos', NULL, 0.2, 0, 500);
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (5, 'Carillas N391', NULL, 12.2, 2, 40);
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (4, 'Placas radiografia', NULL, 40, 6, 20);
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (2, 'Cepillo dental', NULL, 0.9, 6, 300);
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (7, 'Limpieza', 'Limpieza', 100, 1, 20);
INSERT INTO productos (idproducto, producto, descripcion, precio, cantidad, puntoreposicion) VALUES (8, 'Blanqueamiento laser', 'Blanqueamiento laser', 250, 1, 0);
--
-- Data for blobs (OID = 26098) (LIMIT 0,1)
--
INSERT INTO presupuestos (idpresupuesto, presupuesto, descripcion, observaciones) VALUES (1, 'Blanqueamiento', 'Blanqueamiento', 'Blanqueamiento de las piezas dentales');
--
-- Data for blobs (OID = 26110) (LIMIT 0,3)
--
INSERT INTO presupuestosproductos (idpresupuestoproducto, idpresupuesto, idproducto, cantidad, opcional) VALUES (1, 1, 1, 1, false);
INSERT INTO presupuestosproductos (idpresupuestoproducto, idpresupuesto, idproducto, cantidad, opcional) VALUES (2, 1, 7, 1, false);
INSERT INTO presupuestosproductos (idpresupuestoproducto, idpresupuesto, idproducto, cantidad, opcional) VALUES (3, 1, 8, 1, true);
--
-- Data for blobs (OID = 26130) (LIMIT 0,1)
--
INSERT INTO laboratorios (idlaboratorio, laboratorio, cif, direccion, cp, poblacion, provincia, telefono, fax, personacontacto, email, web, observaciones) VALUES (1, 'Chemical, SL', '91341028E', 'C/ Victoria Soledad', '92345', 'Campello', 'Alicante', '945872345', '913582034', 'Carmen', 'chemical@chemical.es', 'www.chemical.es', NULL);
--
-- Data for blobs (OID = 26144) (LIMIT 0,3)
--
INSERT INTO pedidos (idpedido, idlaboratorio, fechasolicitud, fecharecepcion, recibido, observaciones) VALUES (2, 1, '2006-06-01', NULL, false, NULL);
INSERT INTO pedidos (idpedido, idlaboratorio, fechasolicitud, fecharecepcion, recibido, observaciones) VALUES (3, 1, '2006-06-01', NULL, false, NULL);
INSERT INTO pedidos (idpedido, idlaboratorio, fechasolicitud, fecharecepcion, recibido, observaciones) VALUES (1, 1, '2006-06-01', NULL, true, NULL);
--
-- Data for blobs (OID = 26161) (LIMIT 0,8)
--
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (5, 2, 3, 1, NULL, 20.4, NULL, false);
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (6, 2, 4, 1, NULL, 30.15, NULL, false);
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (8, 2, 5, 30, NULL, 19, NULL, false);
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (9, 2, 6, 100, NULL, 0.05, NULL, false);
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (10, 3, 2, 40, NULL, 9.23, NULL, false);
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (4, 1, 5, 100, 2, 5, NULL, true);
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (3, 1, 4, 10, 6, 30, NULL, true);
INSERT INTO detallespedidos (iddetallepedido, idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) VALUES (7, 2, 2, 30, 6, 1.2, NULL, true);
--
-- Data for blobs (OID = 26196) (LIMIT 0,10)
--
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (1, 2, 2, '2006-06-01', '10:00:00', false, true, 60, 'Limpieza bucal');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (6, 1, 2, '2006-06-01', '20:30:00', false, false, 30, 'Arreglo de empaste');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (7, 2, 1, '2006-06-01', '16:45:00', false, true, 30, 'Blanqueamineto lser Limpieza bucal y empaste');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (3, 1, 1, '2006-06-02', '12:30:00', false, true, 90, 'Extraccin muela trasera asd Extraccin de muela');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (2, 1, 2, '2006-06-01', '11:00:00', false, true, 30, 'Blanqueamiento lser asdfasdf');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (4, 1, 1, '2006-06-01', '20:30:00', false, true, 30, 'Limpieza');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (5, 2, 2, '2006-06-01', '19:30:00', false, true, 30, 'Arreglo empaste');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (8, 1, 1, '2006-06-01', '09:00:00', false, false, 30, 'Revisin');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (9, 2, 1, '2006-06-01', '12:00:00', false, false, 30, 'Revisin');
INSERT INTO citas (idcita, idcliente, idempleado, fecha, hora, confirmada, realizada, duracionestimada, descripcion) VALUES (10, 2, 2, '2006-06-02', '11:00:00', false, false, 30, 'Limpieza bucal');
--
-- Data for blobs (OID = 26220) (LIMIT 0,15)
--
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (1, 1, 1, 1, 40);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (2, 3, 1, 1, 0);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (3, 3, 1, 1, 55);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (4, 3, 1, 1, 0);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (5, 3, 1, 1, 0);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (6, 3, 1, 1, 123);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (7, 1, 1, 1, 0);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (8, 1, 1, 1, 123);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (9, 2, 1, 1, 0);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (10, 2, 1, 1, 23);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (11, 4, 1, 1, 0);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (12, 4, 1, 1, 23);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (13, 5, 5, 1, 12.2);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (14, 7, 1, 1, 115.3);
INSERT INTO detallescita (iddetallecita, idcita, idproducto, cantidad, precio) VALUES (15, 3, 1, 1, 45);
--
-- Data for blobs (OID = 26239) (LIMIT 0,5)
--
INSERT INTO facturascliente (idfacturacliente, idcita, fecha, descuento, emitida, pagada, formapago) VALUES (1, 1, '2006-06-01', 0, false, false, NULL);
INSERT INTO facturascliente (idfacturacliente, idcita, fecha, descuento, emitida, pagada, formapago) VALUES (2, 3, '2006-06-01', 0, false, false, NULL);
INSERT INTO facturascliente (idfacturacliente, idcita, fecha, descuento, emitida, pagada, formapago) VALUES (5, 2, '2006-06-01', 0, false, false, NULL);
INSERT INTO facturascliente (idfacturacliente, idcita, fecha, descuento, emitida, pagada, formapago) VALUES (6, 4, '2006-06-01', 0, false, false, NULL);
INSERT INTO facturascliente (idfacturacliente, idcita, fecha, descuento, emitida, pagada, formapago) VALUES (7, 7, '2006-06-01', 0, false, false, NULL);
--
-- Definition for index clientes_pkey (OID = 25969) : 
--
ALTER TABLE ONLY clientes
    ADD CONSTRAINT clientes_pkey PRIMARY KEY (idcliente);
--
-- Definition for index clientes_cliente_key (OID = 25971) : 
--
ALTER TABLE ONLY clientes
    ADD CONSTRAINT clientes_cliente_key UNIQUE (cliente);
--
-- Definition for index clientes_email_key (OID = 25973) : 
--
ALTER TABLE ONLY clientes
    ADD CONSTRAINT clientes_email_key UNIQUE (email);
--
-- Definition for index empleados_pkey (OID = 25983) : 
--
ALTER TABLE ONLY empleados
    ADD CONSTRAINT empleados_pkey PRIMARY KEY (idempleado);
--
-- Definition for index empleados_empleado_key (OID = 25985) : 
--
ALTER TABLE ONLY empleados
    ADD CONSTRAINT empleados_empleado_key UNIQUE (empleado);
--
-- Definition for index historiales_pkey (OID = 26027) : 
--
ALTER TABLE ONLY historiales
    ADD CONSTRAINT historiales_pkey PRIMARY KEY (idhistorial);
--
-- Definition for index historiales_idcliente_key (OID = 26029) : 
--
ALTER TABLE ONLY historiales
    ADD CONSTRAINT historiales_idcliente_key UNIQUE (idcliente);
--
-- Definition for index historiales_idcliente_fkey (OID = 26031) : 
--
ALTER TABLE ONLY historiales
    ADD CONSTRAINT historiales_idcliente_fkey FOREIGN KEY (idcliente) REFERENCES clientes(idcliente) ON UPDATE CASCADE ON DELETE CASCADE;
--
-- Definition for index tiposmailings_pkey (OID = 26044) : 
--
ALTER TABLE ONLY tiposmailings
    ADD CONSTRAINT tiposmailings_pkey PRIMARY KEY (idtipomailing);
--
-- Definition for index tiposmailings_tipomailing_key (OID = 26046) : 
--
ALTER TABLE ONLY tiposmailings
    ADD CONSTRAINT tiposmailings_tipomailing_key UNIQUE (tipomailing);
--
-- Definition for index detallestipomailing_pkey (OID = 26056) : 
--
ALTER TABLE ONLY detallestipomailing
    ADD CONSTRAINT detallestipomailing_pkey PRIMARY KEY (iddetalletipomailing);
--
-- Definition for index detallestipomailing_asunto_key (OID = 26058) : 
--
ALTER TABLE ONLY detallestipomailing
    ADD CONSTRAINT detallestipomailing_asunto_key UNIQUE (asunto);
--
-- Definition for index detallestipomailing_idtipomailing_fkey (OID = 26060) : 
--
ALTER TABLE ONLY detallestipomailing
    ADD CONSTRAINT detallestipomailing_idtipomailing_fkey FOREIGN KEY (idtipomailing) REFERENCES tiposmailings(idtipomailing) ON UPDATE CASCADE ON DELETE CASCADE;
--
-- Definition for index mailingsclientes_pkey (OID = 26072) : 
--
ALTER TABLE ONLY mailingsclientes
    ADD CONSTRAINT mailingsclientes_pkey PRIMARY KEY (idmailingcliente);
--
-- Definition for index mailingsclientes_iddetalletipomailing_fkey (OID = 26074) : 
--
ALTER TABLE ONLY mailingsclientes
    ADD CONSTRAINT mailingsclientes_iddetalletipomailing_fkey FOREIGN KEY (iddetalletipomailing) REFERENCES detallestipomailing(iddetalletipomailing) ON UPDATE CASCADE;
--
-- Definition for index mailingsclientes_idcliente_fkey (OID = 26079) : 
--
ALTER TABLE ONLY mailingsclientes
    ADD CONSTRAINT mailingsclientes_idcliente_fkey FOREIGN KEY (idcliente) REFERENCES clientes(idcliente) ON UPDATE CASCADE;
--
-- Definition for index productos_pkey (OID = 26092) : 
--
ALTER TABLE ONLY productos
    ADD CONSTRAINT productos_pkey PRIMARY KEY (idproducto);
--
-- Definition for index productos_producto_key (OID = 26094) : 
--
ALTER TABLE ONLY productos
    ADD CONSTRAINT productos_producto_key UNIQUE (producto);
--
-- Definition for index presupuestos_pkey (OID = 26104) : 
--
ALTER TABLE ONLY presupuestos
    ADD CONSTRAINT presupuestos_pkey PRIMARY KEY (idpresupuesto);
--
-- Definition for index presupuestos_presupuesto_key (OID = 26106) : 
--
ALTER TABLE ONLY presupuestos
    ADD CONSTRAINT presupuestos_presupuesto_key UNIQUE (presupuesto);
--
-- Definition for index presupuestosproductos_pkey (OID = 26114) : 
--
ALTER TABLE ONLY presupuestosproductos
    ADD CONSTRAINT presupuestosproductos_pkey PRIMARY KEY (idpresupuestoproducto);
--
-- Definition for index presupuestosproductos_idpresupuesto_key (OID = 26116) : 
--
ALTER TABLE ONLY presupuestosproductos
    ADD CONSTRAINT presupuestosproductos_idpresupuesto_key UNIQUE (idpresupuesto, idproducto);
--
-- Definition for index presupuestosproductos_idpresupuesto_fkey (OID = 26118) : 
--
ALTER TABLE ONLY presupuestosproductos
    ADD CONSTRAINT presupuestosproductos_idpresupuesto_fkey FOREIGN KEY (idpresupuesto) REFERENCES presupuestos(idpresupuesto) ON UPDATE CASCADE ON DELETE CASCADE;
--
-- Definition for index presupuestosproductos_idproducto_fkey (OID = 26123) : 
--
ALTER TABLE ONLY presupuestosproductos
    ADD CONSTRAINT presupuestosproductos_idproducto_fkey FOREIGN KEY (idproducto) REFERENCES productos(idproducto) ON UPDATE CASCADE;
--
-- Definition for index laboratorios_pkey (OID = 26136) : 
--
ALTER TABLE ONLY laboratorios
    ADD CONSTRAINT laboratorios_pkey PRIMARY KEY (idlaboratorio);
--
-- Definition for index laboratorios_laboratorio_key (OID = 26138) : 
--
ALTER TABLE ONLY laboratorios
    ADD CONSTRAINT laboratorios_laboratorio_key UNIQUE (laboratorio);
--
-- Definition for index laboratorios_cif_key (OID = 26140) : 
--
ALTER TABLE ONLY laboratorios
    ADD CONSTRAINT laboratorios_cif_key UNIQUE (cif);
--
-- Definition for index pedidos_pkey (OID = 26152) : 
--
ALTER TABLE ONLY pedidos
    ADD CONSTRAINT pedidos_pkey PRIMARY KEY (idpedido);
--
-- Definition for index pedidos_idlaboratorio_fkey (OID = 26154) : 
--
ALTER TABLE ONLY pedidos
    ADD CONSTRAINT pedidos_idlaboratorio_fkey FOREIGN KEY (idlaboratorio) REFERENCES laboratorios(idlaboratorio) ON UPDATE CASCADE;
--
-- Definition for index detallespedidos_pkey (OID = 26165) : 
--
ALTER TABLE ONLY detallespedidos
    ADD CONSTRAINT detallespedidos_pkey PRIMARY KEY (iddetallepedido);
--
-- Definition for index detallespedidos_idpedido_fkey (OID = 26167) : 
--
ALTER TABLE ONLY detallespedidos
    ADD CONSTRAINT detallespedidos_idpedido_fkey FOREIGN KEY (idpedido) REFERENCES pedidos(idpedido) ON UPDATE CASCADE ON DELETE CASCADE;
--
-- Definition for index detallespedidos_idproducto_fkey (OID = 26172) : 
--
ALTER TABLE ONLY detallespedidos
    ADD CONSTRAINT detallespedidos_idproducto_fkey FOREIGN KEY (idproducto) REFERENCES productos(idproducto) ON UPDATE CASCADE;
--
-- Definition for index facturaslaboratorio_pkey (OID = 26185) : 
--
ALTER TABLE ONLY facturaslaboratorio
    ADD CONSTRAINT facturaslaboratorio_pkey PRIMARY KEY (idfacturalaboratorio);
--
-- Definition for index facturaslaboratorio_idpedido_key (OID = 26187) : 
--
ALTER TABLE ONLY facturaslaboratorio
    ADD CONSTRAINT facturaslaboratorio_idpedido_key UNIQUE (idpedido);
--
-- Definition for index facturaslaboratorio_idpedido_fkey (OID = 26189) : 
--
ALTER TABLE ONLY facturaslaboratorio
    ADD CONSTRAINT facturaslaboratorio_idpedido_fkey FOREIGN KEY (idpedido) REFERENCES pedidos(idpedido) ON UPDATE CASCADE;
--
-- Definition for index citas_pkey (OID = 26206) : 
--
ALTER TABLE ONLY citas
    ADD CONSTRAINT citas_pkey PRIMARY KEY (idcita);
--
-- Definition for index citas_idcliente_fkey (OID = 26208) : 
--
ALTER TABLE ONLY citas
    ADD CONSTRAINT citas_idcliente_fkey FOREIGN KEY (idcliente) REFERENCES clientes(idcliente) ON UPDATE CASCADE;
--
-- Definition for index citas_idempleado_fkey (OID = 26213) : 
--
ALTER TABLE ONLY citas
    ADD CONSTRAINT citas_idempleado_fkey FOREIGN KEY (idempleado) REFERENCES empleados(idempleado) ON UPDATE CASCADE;
--
-- Definition for index detallescita_pkey (OID = 26223) : 
--
ALTER TABLE ONLY detallescita
    ADD CONSTRAINT detallescita_pkey PRIMARY KEY (iddetallecita);
--
-- Definition for index detallescita_idcita_fkey (OID = 26225) : 
--
ALTER TABLE ONLY detallescita
    ADD CONSTRAINT detallescita_idcita_fkey FOREIGN KEY (idcita) REFERENCES citas(idcita) ON UPDATE CASCADE ON DELETE CASCADE;
--
-- Definition for index detallescita_idproducto_fkey (OID = 26230) : 
--
ALTER TABLE ONLY detallescita
    ADD CONSTRAINT detallescita_idproducto_fkey FOREIGN KEY (idproducto) REFERENCES productos(idproducto) ON UPDATE CASCADE;
--
-- Definition for index facturascliente_pkey (OID = 26249) : 
--
ALTER TABLE ONLY facturascliente
    ADD CONSTRAINT facturascliente_pkey PRIMARY KEY (idfacturacliente);
--
-- Definition for index facturascliente_idcita_key (OID = 26251) : 
--
ALTER TABLE ONLY facturascliente
    ADD CONSTRAINT facturascliente_idcita_key UNIQUE (idcita);
--
-- Definition for index facturascliente_idcita_fkey (OID = 26253) : 
--
ALTER TABLE ONLY facturascliente
    ADD CONSTRAINT facturascliente_idcita_fkey FOREIGN KEY (idcita) REFERENCES citas(idcita) ON UPDATE CASCADE;
--
-- Definition for trigger tg_detallescita_copiarprecio (OID = 26236) : 
--
CREATE TRIGGER tg_detallescita_copiarprecio
    BEFORE INSERT OR UPDATE ON detallescita
    FOR EACH ROW
    EXECUTE PROCEDURE copiarprecio ();
--
-- Data for sequence public.clientes_idcliente_seq (OID = 25960)
--
SELECT pg_catalog.setval('clientes_idcliente_seq', 3, true);
--
-- Data for sequence public.empleados_idempleado_seq (OID = 25975)
--
SELECT pg_catalog.setval('empleados_idempleado_seq', 4, true);
--
-- Data for sequence public.historiales_idhistorial_seq (OID = 25987)
--
SELECT pg_catalog.setval('historiales_idhistorial_seq', 3, true);
--
-- Data for sequence public.tiposmailings_idtipomailing_seq (OID = 26036)
--
SELECT pg_catalog.setval('tiposmailings_idtipomailing_seq', 2, true);
--
-- Data for sequence public.detallestipomailing_iddetalletipomailing_seq (OID = 26048)
--
SELECT pg_catalog.setval('detallestipomailing_iddetalletipomailing_seq', 3, true);
--
-- Data for sequence public.mailingsclientes_idmailingcliente_seq (OID = 26065)
--
SELECT pg_catalog.setval('mailingsclientes_idmailingcliente_seq', 1, false);
--
-- Data for sequence public.productos_idproducto_seq (OID = 26084)
--
SELECT pg_catalog.setval('productos_idproducto_seq', 8, true);
--
-- Data for sequence public.presupuestos_idpresupuesto_seq (OID = 26096)
--
SELECT pg_catalog.setval('presupuestos_idpresupuesto_seq', 1, true);
--
-- Data for sequence public.presupuestosproductos_idpresupuestoproducto_seq (OID = 26108)
--
SELECT pg_catalog.setval('presupuestosproductos_idpresupuestoproducto_seq', 3, true);
--
-- Data for sequence public.laboratorios_idlaboratorio_seq (OID = 26128)
--
SELECT pg_catalog.setval('laboratorios_idlaboratorio_seq', 1, true);
--
-- Data for sequence public.pedidos_idpedido_seq (OID = 26142)
--
SELECT pg_catalog.setval('pedidos_idpedido_seq', 3, true);
--
-- Data for sequence public.detallespedidos_iddetallepedido_seq (OID = 26159)
--
SELECT pg_catalog.setval('detallespedidos_iddetallepedido_seq', 10, true);
--
-- Data for sequence public.facturaslaboratorio_idfacturalaboratorio_seq (OID = 26177)
--
SELECT pg_catalog.setval('facturaslaboratorio_idfacturalaboratorio_seq', 1, false);
--
-- Data for sequence public.citas_idcita_seq (OID = 26194)
--
SELECT pg_catalog.setval('citas_idcita_seq', 10, true);
--
-- Data for sequence public.detallescita_iddetallecita_seq (OID = 26218)
--
SELECT pg_catalog.setval('detallescita_iddetallecita_seq', 15, true);
--
-- Data for sequence public.facturascliente_idfacturacliente_seq (OID = 26237)
--
SELECT pg_catalog.setval('facturascliente_idfacturacliente_seq', 8, true);
--
-- Comments
--
COMMENT ON SCHEMA public IS 'Standard public schema';
