using System;
using System.Data.Odbc;
using System.Data;


namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de cliente.
	/// </summary>
	public class Cliente : Persona
	{

		private int idCliente;
		private DateTime fechaAlta;
		//private Consulta listaConsultas;

		public Cliente()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
			LimpiarCliente();
		}

		public int gsIdCliente
		{
			get
			{
				return idCliente;
			}
			set
			{
				idCliente = value;
			}
		}

		public DateTime gsFechaAlta
		{
			get
			{
				return fechaAlta;
			}
			set
			{
				//mirar si queremos agregar la fecha en algun formato
				//mediante un metodo de la clase DateTime
				fechaAlta = value;
			}
		}

		public int AgregarDB()
		{
			Consulta cns = new Consulta();

			Utilidades utls = new Utilidades();
			string fecha = utls.FechaPostgres(gsFechaNacimiento);

			string sql = "";
			sql += "insert into clientes (cliente, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, observaciones) values (";
			sql += (gsNombre.Equals(""))? "NULL, " : "'" + gsNombre + "', ";
			sql += (fecha.Equals(""))? "NULL, " : "'" + fecha + "', ";
			sql += (gsDireccion.Equals(""))? "NULL, " : "'" + gsDireccion + "', ";
			sql += (gsCp.Equals(""))? "NULL, " : "'" + gsCp + "', ";
			sql += (gsPoblacion.Equals(""))? "NULL, " : "'" + gsPoblacion + "', ";
			sql += (gsProvincia.Equals(""))? "NULL, " : "'" + gsProvincia + "', ";
			sql += (gsTelefono.Equals(""))? "NULL, " : "'" + gsTelefono + "', ";
			sql += (gsMovil.Equals(""))? "NULL, " : "'" + gsMovil + "', ";
			sql += (gsEmail.Equals(""))? "NULL, " : "'" + gsEmail + "', ";
			sql += (gsObservaciones.Equals(""))? "NULL" : "'" + gsObservaciones + "'";
			sql += "); ";

			cns.ExecNQ("begin; " + sql);
			int cliente = cns.ExecS("select currval('clientes_idcliente_seq'); ");
			cns.ExecNQ((cliente > 0)? "commit;" : "rollback;");
			cns.Cierre();

			return cliente;
		}


		public bool ModificarDB()
		{
			Consulta cns = new Consulta();

			Utilidades utls = new Utilidades();
			string fecha = utls.FechaPostgres(gsFechaNacimiento);

			string sql = "";
			sql += "update clientes set ";
			sql += "cliente = " + ((gsNombre.Equals(""))? "NULL" : "'" + gsNombre + "'") + ", ";
			sql += "fechanacimiento = " + ((fecha.Equals(""))? "NULL" : "'" + fecha + "'") + ", ";
			sql += "direccion = " + ((gsDireccion.Equals(""))? "NULL" : "'" + gsDireccion + "'") + ", ";
			sql += "cp = " + ((gsCp.Equals(""))? "NULL" : "'" + gsCp + "'") + ", ";
			sql += "poblacion = " + ((gsPoblacion.Equals(""))? "NULL" : "'" + gsPoblacion + "'") + ", ";
			sql += "provincia = " + ((gsProvincia.Equals(""))? "NULL" : "'" + gsProvincia + "'") + ", ";
			sql += "telefono = " + ((gsTelefono.Equals(""))? "NULL" : "'" + gsTelefono + "'") + ", ";
			sql += "movil = " + ((gsMovil.Equals(""))? "NULL" : "'" + gsMovil + "'") + ", ";
			sql += "email = " + ((gsEmail.Equals(""))? "NULL" : "'" + gsEmail + "'") + ", ";
			sql += "observaciones = " + ((gsObservaciones.Equals(""))? "NULL" : "'" + gsObservaciones + "'") + " ";			
			sql += "where idcliente = " + gsIdCliente + "; ";

			bool error = cns.ExecNQ(sql) <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;
		}	
	

		public bool EliminarDB(string nombre)
		{
			Consulta cns = new Consulta();

			bool error = cns.ExecNQ("delete from clientes where cliente = '" + nombre + "'; ") <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;
		}


		public bool CargarDB(string condicion)
		{
			string sql = "";
			sql += "select idcliente, cliente, ";
			sql += "case when fechanacimiento is null then '1900' else extract(year from fechanacimiento) end as anyonac, ";
			sql += "case when fechanacimiento is null then '1' else extract(month from fechanacimiento) end as mesnac, ";
			sql += "case when fechanacimiento is null then '1' else extract(day from fechanacimiento) end as dianac, ";
			sql += "case when direccion is null then '' else direccion end as direccion, ";
			sql += "case when cp is null then '' else cp end as cp, ";
			sql += "case when poblacion is null then '' else poblacion end as poblacion, ";
			sql += "case when provincia is null then '' else provincia end as provincia, ";
			sql += "case when telefono is null then '' else telefono end as telefono, ";
			sql += "case when movil is null then '' else movil end as movil, ";
			sql += "case when email is null then '' else email end as email, ";
			sql += "case when observaciones is null then '' else observaciones end as observaciones, ";
			sql += "case when fechaalta is null then '1900' else extract(year from fechaalta) end as anyoalta, ";
			sql += "case when fechaalta is null then '1' else extract(month from fechaalta) end as mesalta, ";
			sql += "case when fechaalta is null then '1' else extract(day from fechaalta) end as diaalta ";
			sql += "from clientes " + condicion;

			Consulta cns = new Consulta();
			OdbcDataReader tupla = cns.ExecR(sql);
			
			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdCliente = tupla.GetInt32(0);
				gsNombre = tupla["cliente"].ToString();

				DateTime fechaPostgres = new DateTime(
					int.Parse(tupla["anyonac"].ToString()), 
					int.Parse(tupla["mesnac"].ToString()), 
					int.Parse(tupla["dianac"].ToString())
					);
				gsFechaNacimiento = fechaPostgres;

				gsDireccion = tupla["direccion"].ToString();
				gsCp = tupla["cp"].ToString();
				gsPoblacion = tupla["poblacion"].ToString();
				gsProvincia = tupla["provincia"].ToString();
				gsTelefono = tupla["telefono"].ToString();
				gsMovil = tupla["movil"].ToString();
				gsEmail = tupla["email"].ToString();
				gsObservaciones = tupla["observaciones"].ToString();
			
				fechaPostgres = new DateTime(
					int.Parse(tupla["anyoalta"].ToString()), 
					int.Parse(tupla["mesalta"].ToString()), 
					int.Parse(tupla["diaalta"].ToString())
					);
				gsFechaAlta = fechaPostgres; 

			}
			else Limpiar();

			cns.Cierre();
			tupla.Close();

			return cargado;
		}

	
		
		public bool CargarIdDB(int id)
		{
			return CargarDB("where idcliente = " + id.ToString() + "; ");
		}

		public bool CargarNombreDB(string nombre)
		{
			return CargarDB(" where cliente = '" + nombre + "'; ");
		}
		
		public void LimpiarCliente()
		{
			idCliente = 0;
			fechaAlta = new DateTime(1900, 1, 1);
			Limpiar();
		}
		public bool Login(string email, string clave)
		{
			Consulta consulta = new Consulta();
			int cuantos = consulta.ExecS(
				"select count(*) as cuantos from clientes where email = '" + email + "' and clave = md5('" + clave + "'); "
				);
			
			if(cuantos>0)
				return true;
			else
                return false;

		}
	}
}
