using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de Detallecita.
	/// </summary>
	public class DetalleCita
	{
		private int idDetalleCita;
		private int idCita;
		private int idProducto;
		private int cantidad;
		private float precio;

		public DetalleCita()
		{
			Limpiar();
		}

		public int gsIdDetalleCita
		{
			get { return idDetalleCita; }
			set { idDetalleCita = value; }
		}

		public int gsIdCita
		{
			get { return idCita; }
			set { idCita = value; }
		}

		public int gsIdProducto
		{
			get { return idProducto; }
			set { idProducto = value; }
		}

		public int gsCantidad
		{
			get { return cantidad; }
			set { cantidad = value; }
		}

		public float gsPrecio
		{
			get { return precio; }
			set { precio = value; }
		}

		public void Limpiar()
		{
			idDetalleCita = 0;
			gsIdCita = 0;
			gsIdProducto = 0;
			gsCantidad = -1;
			gsPrecio = -1;
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "insert into detallescita (idcita, idproducto, cantidad, precio) values (";
			sql += gsIdCita == 0? "NULL, " : gsIdCita.ToString() + ", ";
			sql += gsIdProducto == 0? "NULL, " : gsIdProducto.ToString() + ", ";
			sql += gsCantidad < 0? "NULL, " : gsCantidad.ToString() + ", ";
			sql += gsPrecio < 0? "NULL, " : "'" + gsPrecio.ToString().Replace(",",".") + "' ";
			sql += ");";

			consulta.ExecNQ("begin; " + sql);
			int detallecita = consulta.ExecS("select currval('detallescita_iddetallecita_seq'); ");
			consulta.ExecNQ((detallecita > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return detallecita;
		}

		public bool ModificarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "update detallescita set ";
			sql += "idcita = " + (gsIdCita == 0? "NULL" : gsIdCita.ToString()) + ", ";
			sql += "idproducto = " + (gsIdProducto == 0? "NULL" : gsIdProducto.ToString()) + ", ";
			sql += "cantidad = " + (gsCantidad < 0? "NULL" : gsCantidad.ToString()) + ", ";
			sql += "precio = " + (gsPrecio < 0? "NULL" : "'" + gsPrecio.ToString().Replace(",",".")) + "' ";
			sql += "where iddetallecita = " + gsIdDetalleCita.ToString() + "; ";

			bool error = consulta.ExecNQ(sql) <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool EliminarDB(int id)
		{
			Consulta consulta = new Consulta();

			bool error = consulta.ExecNQ("delete from detallescita where iddetallecita = " + id.ToString() + "; ") <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool CargarDB(int id)
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "select iddetallecita, idcita, idproducto, cantidad, precio ";
			sql += "from detallescita where iddetallecita = " + id.ToString() + "; ";
			OdbcDataReader tupla = consulta.ExecR(sql);

			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdDetalleCita = tupla.GetInt32(0);
				gsIdCita = tupla.GetInt32(1);
				gsIdProducto = tupla.GetInt32(2);
				gsCantidad = tupla.GetInt32(3);
				gsPrecio = tupla.GetFloat(4);
			}
			else Limpiar();

			consulta.Cierre();
			tupla.Close();

			return cargado;
		}
	}
}
