using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de Detallepedido.
	/// </summary>
	public class DetallePedido
	{
		private int idDetallePedido;
		private int idPedido;
		private int idProducto;
		private string modelo;
		private int cantidad;
		private float precioUnitario;
		private float precioVenta;
		private bool recibido;
 
		public DetallePedido()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
			Limpiar();
		}

		public int gsIdDetallePedido
		{
			get
			{
				return idDetallePedido;
			}
			set
			{
				idDetallePedido = value;
			}
		}

		public int gsIdPedido
		{
			get
			{
				return idPedido;
			}
			set
			{
				idPedido = value;
			}
		}

		public int gsIdProducto
		{
			get
			{
				return idProducto;
			}
			set
			{
				idProducto = value;
			}
		}

		public string gsModelo
		{
			get
			{
				return modelo;
			}
			set
			{
				modelo = value;
			}
		}

		public int gsCantidad
		{
			get
			{
				return cantidad;
			}
			set
			{
				cantidad = value;
			}
		}

		public float gsPrecioUnitario
		{
			get
			{
				return precioUnitario;
			}
			set
			{
				precioUnitario = value;
			}
		}

		public float gsPrecioVenta
		{
			get
			{
				return precioVenta;
			}
			set
			{
				precioVenta = value;
			}
		}

		public bool gsRecibido
		{
			get
			{
				return recibido;
			}
			set
			{
				recibido = value;
			}
		}

		public int AgregarDB()
		{
			Consulta cns = new Consulta();

			string sql = "";
			sql += "insert into detallespedidos (idpedido, idproducto, modelo, cantidad, preciounitario, precioventa, recibido) values (";
			sql += (gsIdPedido == 0)? "NULL, " : gsIdPedido.ToString() + ", ";
			sql += (gsIdProducto == 0)? "NULL, " : gsIdProducto.ToString() + ", ";
			sql += (gsModelo.Equals(""))? "NULL, " : "'" + gsModelo.ToString() + "', ";
			sql += (gsCantidad < 0)? "NULL, " : gsCantidad.ToString() + ", ";			
			sql += (gsPrecioUnitario < 0)? "NULL, " : gsPrecioUnitario.ToString() + ", ";			
			sql += (gsPrecioVenta < 0)? "NULL, " : gsPrecioVenta.ToString() + ", ";			
			sql += (gsRecibido)? "'t', " : "'f' ";			
			sql += "); ";

			cns.ExecNQ("begin; " + sql);
			int detallepedido = cns.ExecS("select currval('pedidos_idpedido_seq'); ");
			cns.ExecNQ((detallepedido > 0)? "commit;" : "rollback;");
			cns.Cierre();

			return detallepedido;
		}

		public bool ModificarDB()
		{
			Consulta cns = new Consulta();

			string sql = "";
			sql += "update detallespedidos set ";
			sql += "idpedido = " + ((gsIdPedido == 0)? "NULL" : gsIdPedido.ToString()) + ", ";
			sql += "idproducto = " + ((gsIdProducto == 0)? "NULL" : gsIdProducto.ToString()) + ", ";
			sql += "modelo = " + ((gsModelo.Equals(""))? "NULL" : "'" + gsModelo + "'") + ", ";
			sql += "cantidad = " + ((gsCantidad < 0)? "NULL" : gsCantidad.ToString()) + ", ";
			sql += "preciounitario = " + ((gsPrecioUnitario < 0)? "NULL" : gsPrecioUnitario.ToString()) + ", ";
			sql += "precioventa = " + ((gsPrecioVenta < 0)? "NULL" : gsPrecioVenta.ToString()) + ", ";
			sql += "recibido = " + ((gsRecibido)? "'t'" : "'f'") + " ";			
			sql += "where idpedido = " + gsIdPedido + "; ";

			bool error = cns.ExecNQ(sql) <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool EliminarDB(int id)
		{
			Consulta cns = new Consulta();

			bool error = cns.ExecNQ("delete from detallespedidos where iddetallepedido = '" + id.ToString() + "'; ") <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool CargarDB(int id)
		{
			string sql = "";
			sql += "select iddetallepedido, idpedido, idproducto, modelo, cantidad, preciounitario, precioventa, recibido ";						
			sql += "from empleados where iddetallepedido = " + id.ToString();

			Consulta cns = new Consulta();
			OdbcDataReader tupla = cns.ExecR(sql);
			
			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdDetallePedido = tupla.GetInt32(0);
				gsIdPedido = tupla.GetInt32(1);
				gsIdProducto = tupla.GetInt32(2);
				gsModelo = tupla["modelo"].ToString();				
				gsCantidad = tupla.GetInt32(4);
				gsPrecioUnitario = tupla.GetFloat(5);
				gsPrecioVenta = tupla.GetFloat(6);
				gsRecibido = tupla["recibido"].ToString() == "t";				
			}
			else Limpiar();

			cns.Cierre();
			tupla.Close();

			return cargado;
		}		

		public void Limpiar()
		{
			gsIdDetallePedido = 0;
			gsIdPedido = 0;
			gsIdProducto = 0;
			gsModelo = "";
			gsCantidad = -1;
			gsPrecioUnitario = -1;
			gsPrecioVenta = -1;
			gsRecibido = false;
		}
	}
}
