using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de DetalleTipoMailing.
	/// </summary>
	public class DetalleTipoMailing
	{
		private int idDetalleTipoMailing;
		private int idTipoMailing;
		private string asunto;
		private string texto;

		public DetalleTipoMailing()
		{
			Limpiar();
		}

		public int gsIdDetalleTipoMailing
		{
			get { return idDetalleTipoMailing; }
			set { idDetalleTipoMailing = value; }
		}

		public int gsIdTipoMailing
		{
			get { return idTipoMailing; }
			set { idTipoMailing = value; }
		}

		public string gsAsunto
		{
			get { return asunto; }
			set { asunto = value; }
		}

		public string gsTexto
		{
			get { return texto; }
			set { texto = value; }
		}

		public void Limpiar()
		{
			gsIdDetalleTipoMailing = 0;
			gsIdTipoMailing = 0;
			gsAsunto = "";
			gsTexto = "";
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "insert into detallestipomailing (idtipomailing, asunto, texto) values (";
			sql += gsIdTipoMailing == 0? "NULL, " : gsIdTipoMailing.ToString() + ", ";
			sql += gsAsunto.Equals("")? "NULL, " : "'" + gsAsunto + "', ";
			sql += gsTexto.Equals("")? "NULL" : "'" + gsTexto + "'";
			sql += ");";

			consulta.ExecNQ("begin; " + sql);
			int detalleTipoMailing = consulta.ExecS("select currval('detallestipomailing_iddetalletipomailing_seq'); ");
			consulta.ExecNQ((detalleTipoMailing > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return detalleTipoMailing;
		}

		public bool ModificarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "update detallestipomailing set ";
			//sql += "idtipomailing = " + (gsIdTipoMailing == 0? "NULL" : gsIdTipoMailing.ToString()) + ", ";
			sql += "asunto = " + (gsAsunto.Equals("")? "NULL" : "'" + gsAsunto + "'") + ", ";
			sql += "texto = " + (gsTexto.Equals("")? "NULL" : "'" + gsTexto + "'") + " ";
			sql += "where iddetalletipomailing = " + gsIdDetalleTipoMailing.ToString() + "; ";

			bool error = consulta.ExecNQ(sql) <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool EliminarDB(string detalleTipoMailing)
		{
			Consulta consulta = new Consulta();

			bool error = consulta.ExecNQ("delete from detallestipomailing where asunto = '" + detalleTipoMailing.ToString() + "'; ") <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool CargarIdDetalleTipoMailingDB(int id)
		{
			return CargarDB("where iddetalletipomailing = " + id.ToString());
		}

		public bool CargarAsuntoDB(string asunto)
		{
			return CargarDB("where asunto = '" + asunto + "'");
		}

		public bool CargarDB(string condicion)
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "select iddetalletipomailing, idtipomailing, asunto, texto ";
			sql += "from detallestipomailing " + condicion + "; ";
			OdbcDataReader tupla = consulta.ExecR(sql);

			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdDetalleTipoMailing = tupla.GetInt32(0);
				gsIdTipoMailing = tupla.GetInt32(1);
				gsAsunto = tupla["asunto"].ToString();
				gsTexto = tupla["texto"].ToString();
			}
			else Limpiar();

			consulta.Cierre();
			tupla.Close();

			return cargado;
		}
	}
}
