using System;
using System.Text.RegularExpressions;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de ExpresionesRegulares.
	/// </summary>
	public class ExpresionesRegulares
	{
		private string texto = "\\D";
		private string numero = "\\d";
		private string numeroCorto = "\\d{4}";
		private string cp = "\\d{5}";
		private string telefono = "\\d{9}";
		private string movil = "[6]\\d{8}";
		private string email = "\\S+@\\S+\\.\\S+";
		private string cif = "\\d{8}[A-Z]";
		private string web = "(html://)|(www)+\\.+\\w+\\.\\w";

		public ExpresionesRegulares()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
		}
		public bool ERTexto(string str){
			return (Regex.IsMatch(str, texto));
		}

		public bool ERNumero(string str){
			return (Regex.IsMatch(str, numero));
		}

		public bool ERNumeroCorto(string str){
			return (Regex.IsMatch(str, numeroCorto));
		}
		
		public bool ERCp(string str){
			return (Regex.IsMatch(str, cp));
		}

		public bool ERTelefono(string str){
			return (Regex.IsMatch(str, telefono));
		}

		public bool ERMovil(string str){
			return (Regex.IsMatch(str, movil));
		}

		public bool EREmail(string str){
			return (Regex.IsMatch(str, email));
		}

		public bool ERWeb(string str){
			return (Regex.IsMatch(str, web));
		}

		public bool ERCif(string str){
			return (Regex.IsMatch(str, cif));
		}
	}
}
