using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcisn breve de Historial.
	/// </summary>
	public class Historial
	{
		private int idHistorial;
		private int idCliente;
		private string foto;
		private string historiaDental;
		private int [] piezasSup;
		private int [] piezasInf;

		public Historial()
		{
			piezasSup = new int [16];
			piezasInf = new int [16];
			Limpiar();
		}

		public int gsIdHistorial
		{
			get { return idHistorial; }
			set { idHistorial = value; }
		}

		public int gsIdCliente
		{
			get { return idCliente; }
			set { idCliente = value; }
		}

		public string gsFoto
		{
			get { return foto; }
			set { foto = value; }
		}

		public string gsHistoriaDental
		{
			get { return historiaDental; }
			set { historiaDental = value; }
		}

		public int getPiezasSup(int i)
		{
			return(piezasSup[i]);
		}

		public void setPiezasSup(int i, int val)
		{
			piezasSup[i] = val;
		}

		public int getPiezasInf(int i)
		{
			return(piezasInf[i]);
		}

		public void setPiezasInf(int i, int val)
		{
			piezasInf[i] = val;
		}

		public void Limpiar()
		{
			gsIdHistorial = 0;
			gsIdCliente = 0;
			gsFoto = "";
			gsHistoriaDental = "";
			for (int i = 0; i <16; i++)
			{
				piezasSup[i] = 0;
				piezasInf[i] = 0;
			}
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "insert into historiales (idcliente, foto, ";
			sql += "s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, ";
			sql += "i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, ";
			sql += "historiadental) values ( ";
			sql += gsIdCliente == 0? "NULL, " : gsIdCliente.ToString() + ", ";
			sql += gsFoto.Equals("")? "NULL, " : "'" + gsFoto + "', ";
			
			for(int i = 0; i < 16; i++)
				sql += getPiezasSup(i) + ", ";

			for(int i = 0; i < 16; i++)
				sql += getPiezasInf(i) + ", ";
			
			sql += gsHistoriaDental.Equals("")? "NULL " : "'" + gsHistoriaDental + "' ";
			sql += ");";

			consulta.ExecNQ("begin; " + sql);
			int historial = consulta.ExecS("select currval('historiales_idhistorial_seq'); ");
			consulta.ExecNQ((historial > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return historial;
		}

		public bool ModificarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "update historiales set ";
			sql += "idcliente = " + (gsIdCliente == 0? "NULL" : gsIdCliente.ToString()) + ", ";
			sql += "foto = " + (gsFoto.Equals("")? "NULL" : "'" + gsFoto + "'") + ", ";

			for(int i = 0; i < 16; i++)
				sql += "s" + (i+1) + " = " + getPiezasSup(i) + ", ";

			for(int i = 0; i < 16; i++)
				sql += "i" + (i+1) + " = " + getPiezasInf(i) + ", ";

			sql += "historiadental = " + (gsHistoriaDental.Equals("")? "NULL" : "'" + gsHistoriaDental + "'") + " ";
			sql += "where idhistorial = " + gsIdHistorial.ToString() + "; ";

			bool error = consulta.ExecNQ(sql) <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool EliminarDB(int id)
		{
			Consulta consulta = new Consulta();

			bool error = consulta.ExecNQ("delete from historiales where idhistorial = " + id.ToString() + "; ") <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool CargarHistorialDB(int id)
		{
			return CargarDB("where idhistorial = " + id.ToString());
		}

		public bool CargarClienteDB(int id)
		{
			return CargarDB("where idcliente = " + id.ToString());
		}

		public bool CargarDB(string condicion)
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "select idhistorial, idcliente, ";
			sql += "s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, ";
			sql += "i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15, i16, ";
			sql += "case when foto is null then '' else foto end as foto, ";
			sql += "case when historiadental is null then '' else historiadental end as historiadental ";
			sql += "from historiales " + condicion + "; ";
			OdbcDataReader tupla = consulta.ExecR(sql);

			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdHistorial = tupla.GetInt32(0);
				gsIdCliente = tupla.GetInt32(1);
				gsFoto = tupla["foto"].ToString();
				gsHistoriaDental = tupla["historiadental"].ToString();
				for(int i = 0; i < 16; i++)
				{
					int pau = 2 + i;
					int paula = 18 + i;
					setPiezasSup(i, tupla.GetInt32(pau));
					setPiezasInf(i, tupla.GetInt32(paula));
				}
					
			}
			else Limpiar();

			consulta.Cierre();
			tupla.Close();

			return cargado;
		}
	}
}
