using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de Pedido.
	/// </summary>
	public class Pedido
	{
		private int idPedido;
		private int idLaboratorio;
		private DateTime fechaSolicitud;
		private DateTime fechaRecepcion;
		private bool recibido;
		private string observaciones;

		public Pedido()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
			Limpiar();
		}

		public int gsIdPedido
		{
			get
			{
				return idPedido;
			}
			set
			{
				idPedido = value;
			}
		}

		public int gsIdLaboratorio
		{
			get
			{
				return idLaboratorio;
			}
			set
			{
				idLaboratorio = value;
			}
		}
		public DateTime gsFechaSolucitud
		{
			get
			{
				return fechaSolicitud;
			}
			set
			{
				fechaSolicitud = value;
			}
		}

		public DateTime gsFechaRecepcion
		{
			get
			{
				return fechaRecepcion;
			}
			set
			{
				fechaRecepcion = value;
			}
		}

		public bool gsRecibido
		{
			get
			{
				return recibido;
			}
			set 
			{
				recibido = value;
			}
		}
		
		public string gsObservaciones
		{
			get
			{
				return observaciones;
			}
			set 
			{
				observaciones = value;
			}
		}

		public int AgregarDB()
		{
			Consulta cns = new Consulta();

			Utilidades utls = new Utilidades();
			string fechaSol = utls.FechaPostgres(gsFechaSolucitud);
			string fechaRec = utls.FechaPostgres(gsFechaRecepcion);

			string sql = "";
			sql += "insert into pedidos (idlaboratorio, fechasolicitud, fecharecepcion, recibido, observaciones) values (";
			sql += (gsIdLaboratorio == 0)? "NULL, " : gsIdLaboratorio.ToString() + ", ";
			sql += (fechaSol.Equals(""))? "NULL, " : "'" + fechaSol + "', ";
			sql += (fechaRec.Equals(""))? "NULL, " : "'" + fechaRec + "', ";			
			sql += (gsRecibido)? "'t', " : "'f', ";
			sql += (gsObservaciones.Equals(""))? "NULL, " : "'" + gsObservaciones + "' ";			
			sql += "); ";

			cns.ExecNQ("begin; " + sql);
			int pedido = cns.ExecS("select currval('pedidos_idpedido_seq'); ");
			cns.ExecNQ((pedido > 0)? "commit;" : "rollback;");
			cns.Cierre();

			return pedido;
		}

		public bool ModificarDB()
		{
			Consulta cns = new Consulta();

			Utilidades utls = new Utilidades();
			string fechaSol = utls.FechaPostgres(gsFechaSolucitud);
			string fechaRec = utls.FechaPostgres(gsFechaRecepcion);

			string sql = "";
			sql += "update pedidos set ";
			sql += "idlaboratorio = " + ((gsIdLaboratorio == 0)? "NULL" :  gsIdLaboratorio.ToString()) + ", ";
			sql += "fechasolicitud = " + ((fechaSol.Equals(""))? "NULL" : "'" + fechaSol + "'") + ", ";
			sql += "fecharecepcion = " + ((fechaRec.Equals(""))? "NULL" : "'" + fechaRec + "'") + ", ";
			sql += "recibido = " + ((gsRecibido)? "'t'" : "'f'") + ", ";
			sql += "observaciones = " + ((gsObservaciones.Equals(""))? "NULL" : "'" + gsObservaciones + "'") + " ";
			sql += "where idpedido = " + gsIdPedido + "; ";

			bool error = cns.ExecNQ(sql) <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool EliminarDB(int id)
		{
			Consulta cns = new Consulta();

			bool error = cns.ExecNQ("delete from pedidos where idpedido = '" + id.ToString() + "'; ") <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool CargarDB(int id)
		{
			string sql = "";
			sql += "select ipedido, idlaboratorio, ";
			sql += "case when fechasolicitud is null then '1900' else extract(year from fechasolucitud) end as anyosol, ";
			sql += "case when fechasolicitud is null then '1' else extract(month from fechasolicitud) end as messol, ";
			sql += "case when fechasolicitud is null then '1' else extract(day from fechasolicitud) end as diasol, ";
			sql += "case when fecharecepcion is null then '1900' else extract(year from fecharecepcion) end as anyorec, ";
			sql += "case when fecharecepcion is null then '1' else extract(month from fecharecepcion) end as mesrec, ";
			sql += "case when fecharecepcion is null then '1' else extract(day from fecharecepcion) end as diarec, ";
			sql += "recibido, ";
			sql += "case when obsesrvaciones is null then '' else observaciones end as observaciones ";			
			sql += "from empleados where idpedido = " + id.ToString();

			Consulta cns = new Consulta();
			OdbcDataReader tupla = cns.ExecR(sql);
			
			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdPedido = tupla.GetInt32(0);
				gsIdLaboratorio = tupla.GetInt32(1);

				DateTime fechaPostgres = new DateTime(
					int.Parse(tupla["anyosol"].ToString()), 
					int.Parse(tupla["messol"].ToString()), 
					int.Parse(tupla["diasol"].ToString())
					);
				gsFechaSolucitud = fechaPostgres;

				fechaPostgres = new DateTime(
					int.Parse(tupla["anyorec"].ToString()), 
					int.Parse(tupla["mesrec"].ToString()), 
					int.Parse(tupla["diasrec"].ToString())
					);
				gsFechaRecepcion = fechaPostgres;

				gsRecibido = tupla["recibido"].ToString() == "t";
				gsObservaciones = tupla["observaciones"].ToString();				
			}
			else Limpiar();

			cns.Cierre();
			tupla.Close();

			return cargado;
		}		

		public void Limpiar()
		{
			idPedido = 0;
			fechaSolicitud = new DateTime(1900, 1, 1);
			fechaRecepcion = new DateTime(1900, 1, 1);
			recibido = false;
			observaciones = "";
		}

	}
}
