using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de PresupuestoProducto.
	/// </summary>
	public class PresupuestoProducto
	{
		private int idPresupuestoProducto;
		private int idPresupuesto;
		private int idProducto;
		private int cantidad;
		private bool opcional;

		public PresupuestoProducto()
		{
			Limpiar();
		}

		public int gsIdPresupuestoProducto
		{
			get { return idPresupuestoProducto; }
			set { idPresupuestoProducto = value; }
		}

		public int gsIdPresupuesto
		{
			get { return idPresupuesto; }
			set { idPresupuesto = value; }
		}

		public int gsIdProducto
		{
			get { return idProducto; }
			set { idProducto = value; }
		}

		public int gsCantidad
		{
			get { return cantidad; }
			set { cantidad = value; }
		}

		public bool gsOpcional
		{
			get { return opcional; }
			set { opcional = value; }
		}

		public void Limpiar()
		{
			gsIdPresupuestoProducto = 0;
			gsIdPresupuesto = 0;
			gsIdProducto = 0;
			gsCantidad = -1;
			gsOpcional = false;
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "insert into presupuestosproductos (idpresupuesto, idproducto, cantidad, opcional) values (";
			sql += gsIdPresupuesto == 0? "NULL, " : gsIdPresupuesto.ToString() + ", ";
			sql += gsIdProducto == 0? "NULL, " : gsIdProducto.ToString() + ", ";
			sql += gsCantidad < 0? "NULL, " : gsCantidad.ToString() + ", ";
			sql += gsOpcional? "'t'" : "'f'";
			sql += ");";

			consulta.ExecNQ("begin; " + sql);
			int presupuestoProducto = consulta.ExecS("select currval('presupuestosproductos_idpresupuestoproducto_seq'); ");
			consulta.ExecNQ((presupuestoProducto > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return presupuestoProducto;		
		}

		public bool ModificarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "update presupuestosproductos set ";
			sql += "idpresupuesto = " + (gsIdPresupuesto == 0? "NULL" : gsIdPresupuesto.ToString()) + ", ";
			sql += "idproducto = " + (gsIdProducto == 0? "NULL" : gsIdProducto.ToString()) + ", ";
			sql += "idcantidad = " + (gsCantidad < 0? "NULL" : gsCantidad.ToString()) + ", ";
			sql += "opcional = " + (gsOpcional? "'t'" : "'f'") + " ";
			sql += "where idpresupuestoproducto = " + gsIdPresupuestoProducto.ToString() + "; ";

			bool error = consulta.ExecNQ(sql) <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool EliminarDB(int id)
		{
			Consulta consulta = new Consulta();

			bool error = consulta.ExecNQ("delete from presupuestosproductos where idpresupuestoproducto = " + id.ToString() + "; ") <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool CargarDB(int id)
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "select idpresupuestoproducto, idpresupuesto, idproducto, cantidad, opcional ";
			sql += "from presupuestosproductos where idpresupuestoproducto = " + id.ToString() + "; ";
			OdbcDataReader tupla = consulta.ExecR(sql);

			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdPresupuestoProducto = tupla.GetInt32(0);
				gsIdPresupuesto = tupla.GetInt32(1);
				gsIdProducto = tupla.GetInt32(2);
				gsCantidad = tupla.GetInt32(3);
				gsOpcional = tupla["opcional"].ToString() == "t";
			}
			else Limpiar();

			consulta.Cierre();
			tupla.Close();

			return cargado;
		}
	}
}
