using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de TipoMailing.
	/// </summary>
	public class TipoMailing
	{
		private int idTipoMailing;
		private string tipoMailing;

		public TipoMailing()
		{
			Limpiar();
		}

		public int gsIdTipoMailing
		{
			get { return idTipoMailing; }
			set { idTipoMailing = value; }
		}

		public string gsTipoMailing
		{
			get { return tipoMailing; }
			set { tipoMailing = value; }
		}

		public void Limpiar()
		{
			gsIdTipoMailing = 0;
			gsTipoMailing = "";
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "insert into tiposmailings (tipomailing) values (";
			sql += gsTipoMailing.Equals("")? "NULL" : "'" + gsTipoMailing + "'";
			sql += ");";

			consulta.ExecNQ("begin; " + sql);
			int tipoMailing = consulta.ExecS("select currval('tiposmailings_idtipomailing_seq'); ");
			consulta.ExecNQ((tipoMailing > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return tipoMailing;
		}

		public bool ModificarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "update tiposmailings set ";
			sql += "tipomailing = " + (gsTipoMailing.Equals("")? "NULL" : "'" + gsTipoMailing + "'") + " ";
			sql += "where idtipomailing = " + gsIdTipoMailing.ToString() + "; ";

			bool error = consulta.ExecNQ(sql) <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool EliminarDB(string tipoMailing)
		{
			Consulta consulta = new Consulta();

			bool error = consulta.ExecNQ("delete from tiposmailings where tipomailing = '" + tipoMailing.ToString() + "'; ") <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool CargarIdTipoMailingDB(int id)
		{
			return CargarDB("where idtipomailing = " + id.ToString());
		}

		public bool CargarTipoMailing(string tipoMailing)
		{
			return CargarDB("where tipomailing = '" + tipoMailing + "'");
		}

		public bool CargarDB(string condicion)
		{
			Consulta consulta = new Consulta();

			string sql = "select idtipomailing, tipomailing from tiposmailings " + condicion + "; ";
			OdbcDataReader tupla = consulta.ExecR(sql);

			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdTipoMailing = tupla.GetInt32(0);
				gsTipoMailing = tupla["tipomailing"].ToString();
			}
			else Limpiar();

			consulta.Cierre();
			tupla.Close();

			return cargado;
		}
	}
}
