using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using ClassLibraryClinica;
using System.Data.Odbc;


namespace WebClinica.privado
{
	/// <summary>
	/// Descripcin breve de NuevaCita.
	/// </summary>
	public class NuevaCita : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Calendar Calendario;
		protected System.Web.UI.WebControls.TextBox txDescripcion;
		protected System.Web.UI.WebControls.TextBox txHora;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator1;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.Label Label5;
		protected System.Web.UI.WebControls.DropDownList cbMedico;
		protected System.Web.UI.WebControls.Button btSubmit;
		protected System.Web.UI.WebControls.Label error;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.ListBox lbTratamientos;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Introducir aqu el cdigo de usuario para inicializar la pgina
			if (Session["email"]==null)
			{
				Response.Redirect("../login.aspx");
			}
			if(!Page.IsPostBack)
			{
				System.Data.DataSet dsProd = new System.Data.DataSet();
				ClassLibraryClinica.Consulta con = new Consulta();
				dsProd=con.ExecDS("select * from productos");
				this.lbTratamientos.DataSource=dsProd;
				lbTratamientos.DataTextField=dsProd.Tables[0].Columns["producto"].ToString();
				lbTratamientos.DataValueField=dsProd.Tables[0].Columns["idproducto"].ToString();
				lbTratamientos.DataBind();
				System.Data.DataSet dsMed = new System.Data.DataSet();
				dsMed=con.ExecDS("select * from empleados where numerocolegiado is not null");
				cbMedico.DataSource=dsMed;
				cbMedico.DataTextField=dsMed.Tables[0].Columns["empleado"].ToString();
				cbMedico.DataValueField=dsMed.Tables[0].Columns["idempleado"].ToString();
				cbMedico.DataBind();
			}
		}

		#region Cdigo generado por el Diseador de Web Forms
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: llamada requerida por el Diseador de Web Forms ASP.NET.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Mtodo necesario para admitir el Diseador. No se puede modificar
		/// el contenido del mtodo con el editor de cdigo.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btSubmit.Click += new System.EventHandler(this.btSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btSubmit_Click(object sender, System.EventArgs e)
		{
			if(Calendario.SelectedDate.CompareTo(System.DateTime.Now.Date)<0)
			{
				error.Visible=true;
			}
			else
			{
				ClassLibraryClinica.Citas cita = new ClassLibraryClinica.Citas();
				string [] horaCadena = this.txHora.Text.Split(':');
				DateTime horah=new DateTime(Calendario.SelectedDate.Year,Calendario.SelectedDate.Month,Calendario.SelectedDate.Day,int.Parse(horaCadena[0]),int.Parse(horaCadena[1]),0);
				cita.gsFechaHora=horah;
				cita.gsIdCliente=int.Parse(Session["idCliente"].ToString());
				cita.gsDescripcion=this.txDescripcion.Text;
				cita.gsIdEmpleado=int.Parse(this.cbMedico.SelectedValue.ToString());
				cita.gsDuracionEstimada=1;
				int idConsulta= cita.AgregarDB();
				if(idConsulta>0)
				{		
					int cont=0;
					foreach (System.Web.UI.WebControls.ListItem item in lbTratamientos.Items)
					{
						if(item.Selected)
						{
							cont++;
							System.Data.DataSet dsProd = new System.Data.DataSet();
							ClassLibraryClinica.DetalleCita linea =new ClassLibraryClinica.DetalleCita();
							linea.gsIdCita=idConsulta;
							linea.gsIdProducto=int.Parse(item.Value.ToString());
							linea.gsCantidad=1;
							ClassLibraryClinica.Producto pro = new Producto();
							pro.CargarIdDB(linea.gsIdProducto);
							linea.gsPrecio=pro.gsPrecio;
							if(linea.AgregarDB()<0)
								Response.Redirect("../error.aspx");
						}
					}
					if (cont==0)
					{
						ClassLibraryClinica.DetalleCita linea =new ClassLibraryClinica.DetalleCita();
						linea.gsIdCita=idConsulta;
						linea.gsIdProducto=1;
						linea.gsCantidad=1;
						ClassLibraryClinica.Producto pro = new Producto();
						pro.CargarIdDB(1);
						linea.gsPrecio=pro.gsPrecio;
						if(linea.AgregarDB()<0)
							Response.Redirect("../error.aspx");
					}
					Response.Redirect("Ok.aspx");
				}
			}
		}
	}
}
