using System;
using System.Data;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de Consulta.
	/// </summary>
	public class Consulta
	{
		private string cadena;
		private Int32 consulta;
		private System.Data.Odbc.OdbcConnection conexion;


		public Consulta()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//

			cadena = "DSN=clinica;LowerCaseIdentifier=0;LFConversion=1;Ksqo=1;UnknownSizes=0;Debug=0;UseServerSidePrepare=0;Parse=0;SERVER=localhost;ByteaAsLongVarBinary=0;TextAsLongVarchar=1;ReadOnly=0;FakeOidIndex=0;ConnSettings=;MaxLongVarcharSize=8190;MaxVarcharSize=254;Socket=8192;TrueIsMinus1=0;DisallowPremature=0;DATABASE=clinica;Optimizer=1;UID=postgres;ShowOidColumn=0;UseDeclareFetch=0;CancelAsFreeStmt=0;PWD=000000;BI=0;CommLog=0;Fetch=100;UpdatableCursors=0;ExtraSysTablePrefixes=dd_;UnknownsAsLongVarchar=0;RowVersioning=0;SSLMODE=prefer;PORT=5432;BoolsAsChar=1;ShowSystemTables=0";
			conexion = new OdbcConnection(cadena);

			consulta = 0;

			try
			{
				conexion.Open();			
			}
			catch
			{
				consulta = -2;
				conexion.Close();				
			}						
		}

		public int gsConsulta
		{
			get
			{
				return consulta;
			}
		}

		public int ExecNQ(string orden)	//Ejecuta una sentencia que no es consulta (insert, update)
		{								//Devuelve el nmero de filas afectadas

			OdbcCommand cmd = new OdbcCommand(orden,this.conexion);
			
			try
			{
				consulta = cmd.ExecuteNonQuery();
			}
			catch
			{
				consulta = -3;
			}
			return consulta;
		}

		public int ExecS(string orden)	//Ejecuta una consulta que devuelve un escalar
		{

			OdbcCommand cmd = new OdbcCommand(orden,this.conexion);
			
			try
			{
				consulta = int.Parse(cmd.ExecuteScalar().ToString());
			}
			catch
			{
				consulta = -4;
			}
			return consulta;
		}

		public string DLookup(string orden)	//Ejecuta una consulta que devuelve un escalar
		{

			OdbcCommand cmd = new OdbcCommand(orden,this.conexion);
			string retorno = "";
			try
			{
				retorno = cmd.ExecuteScalar().ToString();
			}
			catch
			{
				consulta = -4;
			}
			return retorno;
		}

		public OdbcDataReader ExecR(string orden)	//Ejecuta una consulta devolviendo un datareader
		{

			OdbcCommand cmd = new OdbcCommand(orden,this.conexion);
			
			OdbcDataReader reader = cmd.ExecuteReader();

			if(!reader.HasRows)
				consulta = -1;
			else
				consulta = 0;
			
			return reader;
		}

		public DataSet ExecDS(string orden)	//Ejecuta una consulta devolviendo un dataset
		{
			
			OdbcDataAdapter DAConsulta = new OdbcDataAdapter(orden,this.conexion);
			DataSet DSConsulta = new DataSet();

			try
			{
				DAConsulta.Fill(DSConsulta, "consulta");
				consulta = 0;
			}
			catch
			{
				consulta = -5;
			}
			
			return DSConsulta;
		}

		public void Cierre()	//Cierra la conexin
		{
			conexion.Close();		
		}

		

	}
}
