using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de Detallepedido.
	/// </summary>
	public class DetallePedido
	{
		private int idDetallePedido;
		private int idPedido;
		private int idProducto;
		private int cantidadPedida;
		private int cantidadRecibida;
		private float precioUnitario;
		private float precioVenta;
		private bool recibido;
 
		public DetallePedido()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
			Limpiar();
		}

		public int gsIdDetallePedido
		{
			get
			{
				return idDetallePedido;
			}
			set
			{
				idDetallePedido = value;
			}
		}

		public int gsIdPedido
		{
			get
			{
				return idPedido;
			}
			set
			{
				idPedido = value;
			}
		}

		public int gsIdProducto
		{
			get
			{
				return idProducto;
			}
			set
			{
				idProducto = value;
			}
		}

		public int gsCantidadPedida
		{
			get
			{
				return cantidadPedida;
			}
			set
			{
				cantidadPedida = value;
			}
		}

		public int gsCantidadRecibida
		{
			get
			{
				return cantidadRecibida;
			}
			set
			{
				cantidadRecibida = value;
			}
		}

		public float gsPrecioUnitario
		{
			get
			{
				return precioUnitario;
			}
			set
			{
				precioUnitario = value;
			}
		}

		public float gsPrecioVenta
		{
			get
			{
				return precioVenta;
			}
			set
			{
				precioVenta = value;
			}
		}

		public bool gsRecibido
		{
			get
			{
				return recibido;
			}
			set
			{
				recibido = value;
			}
		}

		public int AgregarDB()
		{
			Consulta cns = new Consulta();	

			string sql = "";
			sql += "insert into detallespedidos (idpedido, idproducto, cantidadpedida, cantidadrecibida, preciounitario, precioventa, recibido) values (";
			sql += (gsIdPedido == 0)? "NULL, " : gsIdPedido.ToString() + ", ";
			sql += (gsIdProducto == 0)? "NULL, " : gsIdProducto.ToString() + ", ";			
			sql += (gsCantidadPedida < 0)? "NULL, " : gsCantidadPedida.ToString() + ", ";			
			sql += (gsCantidadRecibida < 0)? "NULL, " : gsCantidadRecibida.ToString() + ", ";			
			sql += (gsPrecioUnitario < 0)? "NULL, " : "'" + gsPrecioUnitario.ToString().Replace(",",".")  + "', ";			
			sql += (gsPrecioVenta < 0)? "NULL, " : "'" + gsPrecioVenta.ToString().Replace(",",".") + "', ";			
			sql += (gsRecibido)? "'t', " : "'f' ";			
			sql += "); ";

			cns.ExecNQ("begin; " + sql);
			int detallepedido = cns.ExecS("select currval('detallespedidos_iddetallepedido_seq'); ");
			cns.ExecNQ((detallepedido > 0)? "commit;" : "rollback;");
			cns.Cierre();

			return detallepedido;
		}

		public bool ModificarDB()
		{
			Consulta cns = new Consulta();

			string sql = "";
			sql += "update detallespedidos set ";
			sql += "idpedido = " + ((gsIdPedido == 0)? "NULL" : gsIdPedido.ToString()) + ", ";
			sql += "idproducto = " + ((gsIdProducto == 0)? "NULL" : gsIdProducto.ToString()) + ", ";
			sql += "cantidadPedida = " + ((gsCantidadPedida < 0)? "NULL" : gsCantidadPedida.ToString()) + ", ";
			sql += "cantidadRecibida = " + ((gsCantidadRecibida < 0)? "NULL" : gsCantidadRecibida.ToString()) + ", ";
			sql += "preciounitario = " + ((gsPrecioUnitario < 0)? "NULL" : gsPrecioUnitario.ToString()) + ", ";
			sql += "precioventa = " + ((gsPrecioVenta < 0)? "NULL" : gsPrecioVenta.ToString()) + ", ";
			sql += "recibido = " + ((gsRecibido)? "'t'" : "'f'") + " ";			
			sql += "where idpedido = " + gsIdPedido + "; ";

			bool error = cns.ExecNQ(sql) <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool EliminarDB(int id)
		{
			Consulta cns = new Consulta();

			bool error = cns.ExecNQ("delete from detallespedidos where iddetallepedido = '" + id.ToString() + "'; ") <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;
		}

		public bool CargarDB(int id)
		{
			string sql = "";
			sql += "select iddetallepedido, idpedido, idproducto, cantidadpedida, ";						
			sql += "case when cantidadrecibida is null then 0 else cantidadrecibida end as cantidadrecibida, ";
			sql += "preciounitario, ";
			sql += "case when precioventa is null then 0 else precioventa end as precioventa, ";
			sql += "recibido ";
			sql += "from detallespedidos where iddetallepedido = " + id.ToString();

			Consulta cns = new Consulta();
			OdbcDataReader tupla = cns.ExecR(sql);
			
			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdDetallePedido = tupla.GetInt32(0);
				gsIdPedido = tupla.GetInt32(1);
				gsIdProducto = tupla.GetInt32(2);
				gsCantidadPedida = tupla.GetInt32(3);
				gsCantidadRecibida = tupla.GetInt32(4);
				gsPrecioUnitario = tupla.GetFloat(5);
				gsPrecioVenta = tupla.GetFloat(6);
				gsRecibido = tupla["recibido"].ToString() == "t";				
			}
			else Limpiar();

			cns.Cierre();
			tupla.Close();

			return cargado;
		}		

		public void Limpiar()
		{
			gsIdDetallePedido = 0;
			gsIdPedido = 0;
			gsIdProducto = 0;
			gsCantidadPedida = -1;
			gsCantidadRecibida = -1;
			gsPrecioUnitario = -1;
			gsPrecioVenta = -1;
			gsRecibido = false;
		}
	}
}
