using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de usuario.
	/// </summary>
	public class Empleado : Persona
	{
		private int idEmpleado;
		private float sueldo;
		private string numColegiado;

		public Empleado()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
			LimpiarEmpleado();
		}

		public int gsIdEmpleado
		{
			get
			{
				return idEmpleado;
			}
			set
			{
				idEmpleado = value;
			}
		}
		public float gsSueldo
		{
			get
			{
				return sueldo;
			}
			set
			{
				sueldo = value;
			}
		}

		public string gsNumColegiado
		{
			get
			{
				return numColegiado;
			}
			set
			{
				numColegiado = value;
			}
		}

		public int agregarDB()
		{
			Consulta cns = new Consulta();

			Utilidades utls = new Utilidades();
			string fecha = utls.FechaPostgres(gsFechaNacimiento);


			string sql = "";
			sql += "insert into empleados (empleado, fechanacimiento, direccion, cp, poblacion, provincia, telefono, movil, email, numerocolegiado, sueldo, observaciones) values (";
			sql += (gsNombre.Equals(""))? "NULL, " : "'" + gsNombre + "', ";
			sql += (fecha.Equals(""))? "NULL, " : "'" + fecha + "', ";
			sql += (gsDireccion.Equals(""))? "NULL, " : "'" + gsDireccion + "', ";
			sql += (gsCp.Equals(""))? "NULL, " : "'" + gsCp + "', ";
			sql += (gsPoblacion.Equals(""))? "NULL, " : "'" + gsPoblacion + "', ";
			sql += (gsProvincia.Equals(""))? "NULL, " : "'" + gsProvincia + "', ";
			sql += (gsTelefono.Equals(""))? "NULL, " : "'" + gsTelefono + "', ";
			sql += (gsMovil.Equals(""))? "NULL, " : "'" + gsMovil + "', ";
			sql += (gsEmail.Equals(""))? "NULL, " : "'" + gsEmail + "', ";
			sql += (gsNumColegiado.Equals(""))? "NULL, " : "'" + gsNumColegiado + "', ";
			sql += (gsSueldo < 0)? "NULL, " : gsSueldo.ToString() + ", ";
			sql += (gsObservaciones.Equals(""))? "NULL " : "'" + gsObservaciones + "' ";
			sql += "); ";

			cns.ExecNQ("begin; " + sql);
			int empleado = cns.ExecS("select currval('empleados_idempleado_seq'); ");
			cns.ExecNQ((empleado > 0)? "commit;" : "rollback;");
			cns.Cierre();

			return empleado;
		}

		public bool modificarDB()
		{
			Consulta cns = new Consulta();

			Utilidades utls = new Utilidades();
			string fecha = utls.FechaPostgres(gsFechaNacimiento);

			string sql = "";
			sql += "update empleados set ";
			sql += "empleado = " + ((gsNombre.Equals(""))? "NULL" : "'" + gsNombre + "'") + ", ";
			sql += "fechanacimiento = " + ((fecha.Equals(""))? "NULL" : "'" + fecha + "'") + ", ";
			sql += "direccion = " + ((gsDireccion.Equals(""))? "NULL" : "'" + gsDireccion + "'") + ", ";
			sql += "cp = " + ((gsCp.Equals(""))? "NULL" : "'" + gsCp + "'") + ", ";
			sql += "poblacion = " + ((gsPoblacion.Equals(""))? "NULL" : "'" + gsPoblacion + "'") + ", ";
			sql += "provincia = " + ((gsProvincia.Equals(""))? "NULL" : "'" + gsProvincia + "'") + ", ";
			sql += "telefono = " + ((gsTelefono.Equals(""))? "NULL" : "'" + gsTelefono + "'") + ", ";
			sql += "movil = " + ((gsMovil.Equals(""))? "NULL" : "'" + gsMovil + "'") + ", ";
			sql += "email = " + ((gsEmail.Equals(""))? "NULL" : "'" + gsEmail + "'") + ", ";
			sql += "observaciones = " + ((gsObservaciones.Equals(""))? "NULL" : "'" + gsObservaciones + "'") + ", ";
			sql += "numerocolegiado = " + ((gsNumColegiado.Equals(""))? "NULL" : "'" + gsNumColegiado + "'") + ", ";
			sql += "sueldo = " + ((gsSueldo < 0 )? "NULL" : gsSueldo.ToString()) + " ";
			sql += "where idempleado = " + gsIdEmpleado + "; ";

			bool error = cns.ExecNQ(sql) <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool eliminarDB(string nombre)
		{
			Consulta cns = new Consulta();

			bool error = cns.ExecNQ("delete from empleados where empleado = '" + nombre + "'; ") <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool cargarDB(string condicion)
		{
			string sql = "";
			sql += "select idempleado, empleado, ";
			sql += "case when fechanacimiento is null then '1900' else extract(year from fechanacimiento) end as anyonac, ";
			sql += "case when fechanacimiento is null then '1' else extract(month from fechanacimiento) end as mesnac, ";
			sql += "case when fechanacimiento is null then '1' else extract(day from fechanacimiento) end as dianac, ";
			sql += "case when direccion is null then '' else direccion end as direccion, ";
			sql += "case when cp is null then '' else cp end as cp, ";
			sql += "case when poblacion is null then '' else poblacion end as poblacion, ";
			sql += "case when provincia is null then '' else provincia end as provincia, ";
			sql += "case when telefono is null then '' else telefono end as telefono, ";
			sql += "case when movil is null then '' else movil end as movil, ";
			sql += "case when email is null then '' else email end as email, ";
			sql += "case when observaciones is null then '' else observaciones end as observaciones, ";			
			sql += "case when numerocolegiado is null then '' else numerocolegiado end as numerocolegiado, ";			
			sql += "case when sueldo is null then 0 else sueldo end as sueldo ";			
			sql += "from empleados " + condicion;

			Consulta cns = new Consulta();
			OdbcDataReader tupla = cns.ExecR(sql);
			
			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdEmpleado = tupla.GetInt32(0);
				gsNombre = tupla["empleado"].ToString();

				DateTime fechaPostgres = new DateTime(
					int.Parse(tupla["anyonac"].ToString()), 
					int.Parse(tupla["mesnac"].ToString()), 
					int.Parse(tupla["dianac"].ToString())
					);
				gsFechaNacimiento = fechaPostgres;

				gsDireccion = tupla["direccion"].ToString();
				gsCp = tupla["cp"].ToString();
				gsPoblacion = tupla["poblacion"].ToString();
				gsProvincia = tupla["provincia"].ToString();
				gsTelefono = tupla["telefono"].ToString();
				gsMovil = tupla["movil"].ToString();
				gsEmail = tupla["email"].ToString();
				gsObservaciones = tupla["observaciones"].ToString();
				gsNumColegiado = tupla["numerocolegiado"].ToString();
				gsSueldo = tupla.GetInt16(14);

			}
			else Limpiar();

			cns.Cierre();
			tupla.Close();

			return cargado;
		}

		public bool cargarIdDB(int id)
		{
			return cargarDB("where idempleado = " + id.ToString() + "; ");
		}

		public bool cargarNombreDB(string nombre)
		{
			return cargarDB("where empleado = '" + nombre + "'; ");
		}

		public void LimpiarEmpleado()
		{
			idEmpleado = 0;
			sueldo = -1;
			numColegiado = "";
			Limpiar();
		}
	}
}
