using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de laboratorio.
	/// </summary>
	public class Laboratorio
	{
		private int idLaboratorio;
		private string nombre;
		private string cif;
		private string direccion;
		private string cp;
		private string poblacion;
		private string provincia;
		private string telefono;
		private string fax;
		private string personaContacto;
		private string email;
		private string web;
		private string observaciones;

		public Laboratorio()
		{
			LimpiarLaboratorio();
		}

		public int gsIdLaboratorio
		{
			get
			{
				return idLaboratorio;
			}
			set
			{
				idLaboratorio = value;
			}
		}
		
		public string gsNombre
		{
			get
			{
				return nombre;
			}
			set
			{
				nombre = value;
			}
		}

		public string gsCif
		{
			get
			{
				return cif;
			}
			set
			{
				cif = value;
			}
		}

		public string gsDireccion
		{
			get
			{
				return direccion;
			}
			set
			{
				direccion = value;
			}
		}
		public string gsCp
		{
			get
			{
				return cp;
			}
			set
			{
				cp = value;
			}
		}
		public string gsPoblacion
		{
			get
			{
				return poblacion;
			}
			set
			{
				poblacion = value;
			}
		}
		public string gsProvincia
		{
			get
			{
				return provincia;
			}
			set
			{
				provincia = value;
			}
		}
		public string gsTelefono
		{
			get
			{
				return telefono;
			}
			set
			{
				telefono = value;
			}
		}
		public string gsFax
		{
			get
			{
				return fax;
			}
			set
			{
				fax = value;
			}
		}
		public string gsPersonaContacto
		{
			get
			{
				return personaContacto;
			}
			set
			{
				personaContacto = value;
			}
		}
		public string gsEmail
		{
			get
			{
				return email;
			}
			set
			{
				email = value;
			}
		}
		public string gsWeb
		{
			get
			{
				return web;
			}
			set
			{
				web = value;
			}
		}

		public string gsObservaciones
		{
			get { return observaciones; }
			set { observaciones = value; }
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();
			
			string sql;
			sql  = "INSERT INTO laboratorios (laboratorio, cif, direccion, cp, poblacion, provincia, telefono, fax, personacontacto, email, web, observaciones) values (";
			sql += (gsNombre.Equals(""))? "NULL, " : "'" + gsNombre + "', ";
			sql += (gsCif.Equals(""))? "NULL, " : "'" + gsCif + "', ";
			sql += (gsDireccion.Equals(""))? "NULL, " : "'" + gsDireccion + "', ";
			sql += (gsCp.Equals(""))? "NULL, " : "'" + gsCp + "', ";
			sql += (gsPoblacion.Equals(""))? "NULL, " : "'" + gsPoblacion + "', ";
			sql += (gsProvincia.Equals(""))? "NULL, " : "'" + gsProvincia + "', ";
			sql += (gsTelefono.Equals(""))? "NULL, " : "'" + gsTelefono + "', ";
			sql += (gsFax.Equals(""))? "NULL, " : "'" + gsFax + "', ";
			sql += (gsPersonaContacto.Equals(""))? "NULL, " : "'" + gsPersonaContacto + "', ";
			sql += (gsEmail.Equals(""))? "NULL, " : "'" + gsEmail + "', ";
			sql += (gsWeb.Equals(""))? "NULL, " : "'" + gsWeb  + "', ";
			sql += (gsObservaciones.Equals(""))? "NULL" : "'" + gsObservaciones + "'";
			sql += "); ";
			
			consulta.ExecNQ("begin; " + sql);
			int laboratorio = consulta.ExecS("select currval('laboratorios_idlaboratorio_seq'); ");
			consulta.ExecNQ((laboratorio > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return laboratorio;
		}

		public bool ModificarDB()
		{
			Consulta cns = new Consulta();

			string sql = "";
			sql += "update laboratorios set ";
			sql += "laboratorio = " + ((gsNombre.Equals(""))? "NULL" : "'" + gsNombre + "'") + ", ";
			sql += "cif = " + ((gsCif.Equals(""))? "NULL" : "'" + gsCif + "'") + ", ";
			sql += "direccion = " + ((gsDireccion.Equals(""))? "NULL" : "'" + gsDireccion + "'") + ", ";
			sql += "cp = " + ((gsCp.Equals(""))? "NULL" : "'" + gsCp + "'") + ", ";
			sql += "poblacion = " + ((gsPoblacion.Equals(""))? "NULL" : "'" + gsPoblacion + "'") + ", ";
			sql += "provincia = " + ((gsProvincia.Equals(""))? "NULL" : "'" + gsProvincia + "'") + ", ";
			sql += "telefono = " + ((gsTelefono.Equals(""))? "NULL" : "'" + gsTelefono + "'") + ", ";
			sql += "fax = " + ((gsFax.Equals(""))? "NULL" : "'" + gsFax + "'") + ", ";
			sql += "personaContacto = " + ((gsPersonaContacto.Equals(""))? "NULL" : "'" + gsPersonaContacto + "'") + ", ";
			sql += "email = " + ((gsEmail.Equals(""))? "NULL" : "'" + gsEmail + "'") + ", ";
			sql += "web = " + ((gsWeb.Equals(""))? "NULL" : "'" + gsWeb + "'") + ", ";
			sql += "observaciones = " + ((gsObservaciones.Equals(""))? "NULL" : "'" + gsObservaciones + "'") + " ";
			sql += "where idlaboratorio = " + gsIdLaboratorio + "; ";

			bool error = cns.ExecNQ(sql) <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;
		}

		public bool EliminarDB(string nombre)
		{
			Consulta cns = new Consulta();

			bool error = cns.ExecNQ("delete from laboratorios where laboratorio = '" + nombre + "'; ") <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;
		}

		public bool CargarDB(string condicion)
		{
			string sql = "";
			sql += "select idlaboratorio, laboratorio, ";
			sql += "case when cif is null then '' else cif end as cif, ";
			sql += "case when direccion is null then '' else direccion end as direccion, ";
			sql += "case when cp is null then '' else cp end as cp, ";
			sql += "case when poblacion is null then '' else poblacion end as poblacion, ";
			sql += "case when provincia is null then '' else provincia end as provincia, ";
			sql += "case when telefono is null then '' else telefono end as telefono, ";
			sql += "case when fax is null then '' else fax end as fax, ";
			sql += "case when personaContacto is null then '' else personaContacto end as personaContacto, ";
			sql += "case when email is null then '' else email end as email, ";
			sql += "case when web is null then '' else web end as web, ";
			sql += "case when observaciones is null then '' else observaciones end as observaciones ";
			sql += "from laboratorios " + condicion + "; ";

			Consulta cns = new Consulta();
			OdbcDataReader tupla = cns.ExecR(sql);
			
			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdLaboratorio = tupla.GetInt16(0);
				gsNombre = tupla["laboratorio"].ToString();
				gsCif = tupla["cif"].ToString();
				gsDireccion = tupla["direccion"].ToString();
				gsCp = tupla["cp"].ToString();
				gsPoblacion = tupla["poblacion"].ToString();
				gsProvincia = tupla["provincia"].ToString();
				gsTelefono = tupla["telefono"].ToString();
				gsFax = tupla["fax"].ToString();
				gsPersonaContacto = tupla["personaContacto"].ToString();
				gsEmail = tupla["email"].ToString();
				gsWeb = tupla["web"].ToString();
				gsObservaciones = tupla["observaciones"].ToString();
			}
			else LimpiarLaboratorio();

			cns.Cierre();
			tupla.Close();

			return cargado;
		}

		public bool CargarNombreDB(string nombre)
		{
			return CargarDB("where laboratorio = '" + nombre + "' ");
		}

		public void LimpiarLaboratorio()
		{
			gsIdLaboratorio = 0;
			gsNombre = "";
			gsCif = "";
			gsDireccion = "";
			gsCp = "";
			gsPoblacion = "";
			gsProvincia = "";
			gsTelefono = "";
			gsFax = "";
			gsPersonaContacto = "";
			gsEmail = "";
			gsWeb = "";
			gsObservaciones = "";
		}
	}
}
