using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de MailingCliente.
	/// </summary>
	public class MailingCliente
	{
		private int idMailingCliente;
		private int idDetalleTipoMailing;
		private int idCliente;
		private DateTime fechaHora;

		public MailingCliente()
		{
			Limpiar();
		}

		public int gsIdMailingCliente
		{
			get { return idMailingCliente; }
			set { idMailingCliente = value; }
		}

		public int gsIdDetalleTipoMailing
		{
			get { return idDetalleTipoMailing; }
			set { idDetalleTipoMailing = value; }
		}

		public int gsIdCliente
		{
			get { return idCliente; }
			set { idCliente = value; }
		}

		public DateTime gsFechaHora
		{
			get { return fechaHora; }
			set { fechaHora = value; }
		}

		public void Limpiar()
		{
			gsIdMailingCliente = 0;
			gsIdDetalleTipoMailing = 0;
			gsIdCliente = 0;
			gsFechaHora = new DateTime(1900, 1, 1);
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "insert into mailingsclientes (idmailingcliente, iddetalletipomailing, idcliente) values (";
			sql += gsIdDetalleTipoMailing == 0? "NULL, " : gsIdDetalleTipoMailing.ToString() + ", ";
			sql += gsIdCliente == 0? "NULL" : gsIdCliente.ToString();
			sql += ");";

			consulta.ExecNQ("begin; " + sql);
			int mailingcliente = consulta.ExecS("select currval('mailingsclientes_idmailingcliente_seq'); ");
			consulta.ExecNQ((mailingcliente > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return mailingcliente;
		}

		public bool ModificarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "update mailingsclientes set ";
			sql += "iddetalletipomailing = " + (gsIdDetalleTipoMailing == 0? "NULL" : gsIdDetalleTipoMailing.ToString()) + ", ";
			sql += "idcliente = " + (gsIdCliente == 0? "NULL" : gsIdCliente.ToString()) + " ";
			sql += "where idmailingcliente = " + gsIdMailingCliente.ToString() + "; ";

			bool error = consulta.ExecNQ(sql) <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool EliminarDB(int id)
		{
			Consulta consulta = new Consulta();

			bool error = consulta.ExecNQ("delete from mailingsclientes where idmailingcliente = " + id.ToString() + "; ") <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool CargarDB(int id)
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "select idmailingcliente, iddetalletipomailing, idcliente, ";
			sql += "extract(year from fecha) end as anyo, ";
			sql += "extract(month from fecha) end as mes, ";
			sql += "extract(day from fecha) end as dia, ";
			sql += "extract(hour from hora) end as hora, ";
			sql += "extract(minute from hora) end as minutos, ";
			sql += "extract(second from hora) end as segundos, ";
			sql += "from mailingsclientes where idmailingcliente = " + id.ToString() + "; ";
			OdbcDataReader tupla = consulta.ExecR(sql);

			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdMailingCliente = tupla.GetInt32(0);
				gsIdDetalleTipoMailing = tupla.GetInt32(1);
				gsIdCliente = tupla.GetInt32(2);
				DateTime fechaHoraPostgres = new DateTime(
					int.Parse(tupla["anyo"].ToString()), 
					int.Parse(tupla["mes"].ToString()), 
					int.Parse(tupla["dia"].ToString()),
					int.Parse(tupla["hora"].ToString()),
					int.Parse(tupla["minutos"].ToString()),
					int.Parse(tupla["segundos"].ToString())
					);
				gsFechaHora = fechaHoraPostgres;
			}
			else Limpiar();

			consulta.Cierre();
			tupla.Close();

			return cargado;
		}
	}
}
