using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de Presupuesto.
	/// </summary>
	public class Presupuesto
	{
		private int idPresupuesto;
		private string presupuesto;
		private string descripcion;
		private string observaciones;

		public Presupuesto()
		{
			Limpiar();
		}

		public int gsIdPresupuesto
		{
			get { return idPresupuesto; }
			set { idPresupuesto = value; }
		}

		public string gsPresupuesto
		{
			get { return presupuesto; }
			set { presupuesto = value; }
		}

		public string gsDescripcion
		{
			get { return descripcion; }
			set { descripcion = value; }
		}

		public string gsObservaciones
		{
			get { return observaciones; }
			set { observaciones = value; }
		}

		public void Limpiar()
		{
			gsIdPresupuesto = 0;
			gsPresupuesto = "";
			gsDescripcion = "";
			gsObservaciones = "";
		}

		public int AgregarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "insert into presupuestos (idpresupuesto, presupuesto, descripcion, observaciones) values (";
			sql += gsIdPresupuesto == 0? "NULL, " : gsIdPresupuesto.ToString() + ", ";
			sql += gsPresupuesto.Equals("")? "NULL, " : "'" + gsPresupuesto + "', ";
			sql += gsDescripcion.Equals("")? "NULL, " : "'" + gsDescripcion + "', ";
			sql += gsObservaciones.Equals("")? "NULL" : "'" + gsObservaciones + "'";
			sql += ");";

			consulta.ExecNQ("begin; " + sql);
			int presupuesto = consulta.ExecS("select currval('presupuestos_idpresupuesto_seq'); ");
			consulta.ExecNQ((presupuesto > 0)? "commit;" : "rollback;");
			consulta.Cierre();

			return presupuesto;		
		}

		public bool ModificarDB()
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "update presupuestos set ";
			sql += "presupuesto = " + (gsPresupuesto.Equals("")? "NULL" : "'" + gsPresupuesto + "'") + ", ";
			sql += "descripcion = " + (gsDescripcion.Equals("")? "NULL" : "'" + gsDescripcion + "'") + ", ";
			sql += "observaciones = " + (gsObservaciones.Equals("")? "NULL" : "'" + gsObservaciones + "'") + " ";
			sql += "where idpresupuesto = " + gsIdPresupuesto.ToString() + "; ";

			bool error = consulta.ExecNQ(sql) <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool EliminarDB(int id)
		{
			Consulta consulta = new Consulta();

			bool error = consulta.ExecNQ("delete from presupuestos where idpresupuesto = " + id.ToString() + "; ") <= 0;
			consulta.ExecNQ(!error? "commit;" : "rollback;");
			consulta.Cierre();

			return !error;
		}

		public bool CargarIdPresupuestoDB(int id)
		{
			return CargarDB("where idpresupuesto = " + id.ToString());
		}

		public bool CargarPresupuestoDB(string presupuesto)
		{
			return CargarDB("where presupuesto = '" + presupuesto + "'");
		}

		public bool CargarDB(string condicion)
		{
			Consulta consulta = new Consulta();

			string sql = "";
			sql += "select idpresupuesto, presupuesto, ";
			sql += "case when descripcion is null then '' else descripcion end as descripcion, ";
			sql += "case when observaciones is null then '' else observaciones end as observaciones ";
			sql += "from presupuestos " + condicion + "; ";
			OdbcDataReader tupla = consulta.ExecR(sql);

			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdPresupuesto = tupla.GetInt32(0);
				gsPresupuesto = tupla["presupuesto"].ToString();
				gsDescripcion = tupla["descripcion"].ToString();
				gsObservaciones = tupla["observaciones"].ToString();
			}
			else Limpiar();

			consulta.Cierre();
			tupla.Close();

			return cargado;
		}
	}
}
