using System;
using System.Data.Odbc;

namespace ClassLibraryClinica
{
	/// <summary>
	/// Descripcin breve de Producto.
	/// </summary>
	public class Producto
	{
		private int idProducto;
		private string nombre;
		private string descripcion;
		private float precio;
		private int cantidad;
		private int puntoReposicion;

		public Producto()
		{
			Limpiar();
		}

		public int gsIdProducto
		{
			get
			{
				return idProducto;
			}
			set
			{
				idProducto = value;
			}
		}

		public string gsNombre
		{
			get
			{
				return nombre;
			}
			set
			{
				nombre = value;
			}
		}

		public string gsDescripcion
		{
			get
			{
				return descripcion;
			}
			set
			{
				descripcion	= value;
			}
		}

		public float gsPrecio
		{
			get
			{
				return precio;
			}
			set
			{
				precio = value;
			}
		}

		public int gsCantidad
		{
			get
			{
				return cantidad;
			}
			set
			{
				cantidad = value;
			}
		}

		public int gsPuntoReposicion
		{
			get
			{
				return puntoReposicion;
			}
			set
			{
				puntoReposicion = value;
			}
		}

		public int AgregarDB()
		{
			Consulta cns = new Consulta();

			string sql = "";
			sql += "insert into productos (producto, descripcion, precio, cantidad, puntoreposicion) values (";
			sql += (gsNombre.Equals(""))? "NULL, " : "'" + gsNombre + "', ";
			sql += (gsDescripcion.Equals(""))? "NULL, " : "'" + gsDescripcion + "', ";
			sql += (gsPrecio == 0)? "NULL, " : "'" + gsPrecio.ToString().Replace(",",".") + "', ";
			sql += "'" + gsCantidad + "', ";	//Nunca habra cantidad = NULL, al insertar ser 0
			sql += (gsPuntoReposicion == 0)? "NULL, " : "'" + gsPuntoReposicion + "'";
			sql += "); ";

			cns.ExecNQ("begin; " + sql);
			int producto = cns.ExecS("select currval('productos_idproducto_seq'); ");
			cns.ExecNQ((producto > 0)? "commit;" : "rollback;");
			cns.Cierre();

			return producto;
		}

		public bool ModificarDB()
		{	//OJO NO SE MODIFICA LA CANTIDAD DESDE AQUI PORQUE SI NO, NO VA EL MANTENIMIENTO
			Consulta cns = new Consulta();

			string sql = "";
			sql += "update productos set ";
			sql += "producto = " + ((gsNombre.Equals(""))? "NULL" : "'" + gsNombre + "'") + ", ";
			sql += "descripcion = " + ((gsDescripcion.Equals(""))? "NULL" : "'" + gsDescripcion + "'") + ", ";
			sql += "precio = " + ((gsPrecio < 0)? "NULL" :  gsPrecio.ToString()) + " , ";
			sql += "puntoreposicion = " + ((gsPuntoReposicion < 0)? "NULL" :  gsPuntoReposicion.ToString())  ;			
			sql += " where idproducto = " + gsIdProducto + "; ";

			bool error = cns.ExecNQ(sql) <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			 
		}

		public bool EliminarDB(string nombre)
		{
			Consulta cns = new Consulta();

			bool error = cns.ExecNQ("delete from productos where producto = '" + nombre + "'; ") <= 0;
			cns.ExecNQ(!error? "commit;" : "rollback;");
			cns.Cierre();

			return !error;			
		}

		public bool CargarDB(string condicion)
		{
			string sql = "";
			sql += "select idproducto, producto, ";
			sql += "case when descripcion is null then '' else descripcion end as descripcion, ";
			sql += "case when precio is null then 0 else precio end as precio, ";
			sql += "case when cantidad is null then 0 else cantidad end as cantidad, ";
			sql += "case when puntoreposicion is null then 0 else puntoreposicion end as puntoreposicion ";
			sql += "from productos " + condicion + "; ";

			Consulta cns = new Consulta();
			OdbcDataReader tupla = cns.ExecR(sql);
			
			bool cargado = tupla.Read();
			if (cargado)
			{
				gsIdProducto = tupla.GetInt32(0);
				gsNombre = tupla["producto"].ToString();
				gsDescripcion = tupla["descripcion"].ToString();
				gsPrecio = tupla.GetFloat(3);
				gsCantidad = tupla.GetInt32(4);
				gsPuntoReposicion = tupla.GetInt32(5);
			}
			else Limpiar();

			cns.Cierre();
			tupla.Close();

			return cargado;
		}

		public bool CargarIdDB(int id)
		{
			return CargarDB("where idproducto = " + id.ToString());
		}

		public bool CargarNombreDB(string nombre)
		{
			return CargarDB("where producto = '" + nombre + "'");
		}

		public void Limpiar()
		{
			idProducto = 0;
			nombre = "";
			descripcion = "";
			precio = -1;
			cantidad = -1;
			puntoReposicion = -1;
		}
	}
}
